﻿/*
Название: MakeImposition.jsx
Приложение для использования: Adobe InDesign CS4, CS5, CS6
Версия: 1.0
Язык реализации (Среда): JavaScript (ExtendScript Toolkit 2)
Операционные системы (Платформы): PC, Macintosh (Windows, Mac OS)
Условия распространения: Бесплатно; На Ваш риск
Назначение: Создает новый документ с  шаблоном спуска 
Примечание: Создается дополнительный файл MakeImposition.ini для хранения настроек
Техническая поддержка: Sergey-Anosov@yandex.ru
https://sites.google.com/site/dtpscripting
===================================================
Name: MakeImposition.jsx
Application to use with: Adobe InDesign CS4, CS5, CS6
Version: 1.0
Program language (Environment): JavaScript (ExtendScript Toolkit 2)
Operating systems (Platforms): PC, Macintosh (Windows, Mac OS)
Distribution conditions: Freeware; At your own risk
Functions: Creates a new document containing template for imposition
Note: Creates an additional file MakeImposition.ini for setup data
Technical support: Sergey-Anosov@yandex.ru
https://sites.google.com/site/dtpscripting
*/
// описание глобальных переменных
//
// название скрипта
var the_title = "MakeImposition";
// версия скрипта
var the_version = "1.0";
 // активный док-т
var AD;
 // активный слой
var AL;
 // выбранный слой
var SEL_LAYER;
 // активная страница
var AP;
 // страница мастера
var MP;
// активный разворот
var AS;
// результат текстового ввода
var INP_OK = true;
// обрезные размеры фрейма
var W_FINAL;// ширина
var H_FINAL;// высота
// начальные обрезные размеры фрейма
var W_FINAL_INI;// ширина
var H_FINAL_INI;// высота
// полные размеры фрейма (с учетом вылетов)
var W_FULL;// ширина
var H_FULL;// высота
// вылеты фрейма
var BLEED_T;// верхний
var BLEED_B;// нижний
var BLEED_L;// левый 
var BLEED_R;// правый
// начальные вылеты фрейма
var BLEED_T_INI;// верхний
var BLEED_B_INI;// нижний
var BLEED_L_INI;// левый 
var BLEED_R_INI;// правый
// реальные вылеты с учетом ориентации (поворота)
var BLEED_T_VAL;// верхний
var BLEED_B_VAL;// нижний
var BLEED_L_VAL;// левый 
var BLEED_R_VAL;// правый
// начальные промежутки между фреймами
var GUTTER_H_INI;// по горизонтали
var GUTTER_V_INI;// по вертикали
// количество промежутков
var N_GUT_H;// по горизонтали
var N_GUT_V;// по вертикали
// промежутки между фреймами
var GUTTER_H;// по горизонтали
var GUTTER_V;// по вертикали
// промежутки между фреймами только по центру
var H_GUT_CENTER;// по горизонтали
var V_GUT_CENTER;// по вертикали
// начальные значения для промежутков только по центру
var H_GUT_CENTER_INI;// по горизонтали
var V_GUT_CENTER_INI;// по вертикали
// значение для построения меток
var DRAW_CROP;
// начальное значение для построения меток
var DRAW_CROP_INI;
// белый контур вокруг меток
var WHITE_CONT;
// начальное значение для белого контура вокруг меток
var WHITE_CONT_INI;
// метки в промежутках
var CROP_IN_GUT;
// начальное значение для меток в промежутках
var CROP_IN_GUT_INI;
// дополнительный слой для меток
var ADD_LAYER;
// начальное значение для дополнительного слоя для меток
var ADD_LAYER_INI;
// длины меток
var MARKS_LEN_H;// по горизонтали
var MARKS_LEN_V;// по вертикали
// начальные длины меток
var MARKS_LEN_H_INI;// по горизонтали
var MARKS_LEN_V_INI;// по вертикали
// реальные длины меток с учетом отступов (то, что выступает за габарит фреймов)
var MARKS_LEN_V_T;// вверху
var MARKS_LEN_V_B;// внизу
var MARKS_LEN_H_L;// слева
var MARKS_LEN_H_R;// справа
// реальные вылеты фрейма с учетом ориентации
var BLEED_T_VAL;// вверху
var BLEED_B_VAL;// внизу
var BLEED_L_VAL;// слева
var BLEED_R_VAL;// справа
// начальные отступы меток
var MARKS_OFFS_H_INI;// по горизонтали
var MARKS_OFFS_V_INI;// по вертикали
// метки вне фреймов
var CROP_OUT;
// начальное значение для меток вне фреймов
var CROP_OUT_INI;
// добавлять метки вылетов (по полному формату)
var ADD_BLEED_MARKS;
// добавлять метки вылетов начальное значение
var ADD_BLEED_MARKS_INI;
// добавлять центральные метки
var ADD_CENTER_MARKS;
// добавлять центральные метки начальное значение
var ADD_CENTER_MARKS_INI;
// положение центральных меток
var ADD_CENTER_MARKS_POS;
// положение центральных меток начальное значение
var ADD_CENTER_MARKS_POS_INI;
// толщина меток
var MARKS_SW_NUM;
// начальная толщина меток
var MARKS_SW_NUM_INI;
// единицы для толщины меток
var MARKS_SW_UNITS;
// начальные единицы для толщины меток
var MARKS_SW_UNITS_INI;
// количество фреймов в спуске 
var N_FRAMES_V;// по вертикали
var N_FRAMES_H;// по горизонтали
// начальное количество фреймов на спуске
var N_FRAMES_V_INI;// по вертикали
var N_FRAMES_H_INI;// по горизонтали
// дополнительные поля документа
var MARGIN_T;// верхнее
var MARGIN_B;// нижнее
var MARGIN_L;// левое
var MARGIN_R;// правое
// начальные значения дополнительных полей документа
var MARGIN_T_INI;// верхнее
var MARGIN_B_INI;// нижнее
var MARGIN_L_INI;// левое
var MARGIN_R_INI;// правое
// единицы измерения
var UNITS;
// начальный индекс для единиц измерения
var UNITS_INDEX_INI;
// ссылка на файл скрипта
var SCRIPT_FILE = new File();
// ссылка на файл настроек
var INI_FILE = new File();
// ссылка на папку со скриптами
var SCRIPT_FOLDER = new Folder();
// наличие файла настроек
var INI_EXISTS = true;
// результат чтения файла настроек
var INI_ERR = false;
// мастер объект для прямоугольников
var MASTER_RECT;
// создан ли мастер объект для прямоугольников
var MASTER_RECT_MADE = false;
// мастера для вертикальных меток
var MASTER_VER_CROP;
// мастера для горизонтальных меток
var MASTER_HOR_CROP;
// создан ли мастер для вертикальных меток
var MASTER_VER_CROP_MADE = false;
// создан ли мастер для горизонтальных меток
var MASTER_HOR_CROP_MADE = false;
// строить ли направляющие
var DRAW_GUIDES;
// строить ли направляющие начальное значение
var DRAW_GUIDES_INI;
// направляющие по обрезному формату
var GUIDES_CROP;
// направляющие по обрезному формату начальное значение
var GUIDES_CROP_INI;
// направляющие по полному формату
var GUIDES_FULL;
// направляющие по полному формату начальное значение
var GUIDES_FULL_INI;
// направляющие по центру
var GUIDES_CENTER;
// направляющие по центру начальное значение
var GUIDES_CENTER_INI;
// массив созданных фреймов
var FRAMES = new Array();
// ориентация фреймов ( поворот )
var FRAMES_ORIENT = new Array();
// размеры документа
var DOC_W;// ширина
var DOC_H;// высота
// ряды фреймов
var top_frames = new Array();// верхний 
var bottom_frames = new Array();// нижний
var left_frames = new Array();// левый
var right_frames = new Array();// правый
// ориентация в рядах фреймов
var top_frames_orient = new Array();// верхний 
var bottom_frames_orient = new Array();// нижний
var left_frames_orient = new Array();// левый
var right_frames_orient = new Array();// правый
// ориентация фреймов
var ORIENT;
// нач. значение для ориентации фреймов
var ORIENT_INI;
// текст в диалоге для ориентации фреймов
var ORIENT_TEXT;
// смена ориентации фреймов в спуске
var CHANGE;
// начальное значение смены ориентации фреймов
var CHANGE_INI;
// массив сообщений об ошибках ввода
var BAD_VAL_MSG_ARR = new Array();
// массив текстовых сокращений для единиц измерений
//                                                                              0        1        2        3          4        5         6      7
var UNITS_TEXT_ARRAY = new Array( "pt", "pc", "in", "ind", "mm", "cm", "ci", "ag" );
// точность сравнения координат
var PREC = 0.0001;
// файловая система
var WFS = true;
//
// вызов главной подпрограммы
main();
// окончание выполнения скрипта :)))
//
// блок описания подпрограмм
// основная подпрограмма
function main() 
{
	DIALOG_INI();
	the_exit(the_title+":\n\n"+"Done!");
};//end main()
//
// подпрограмма определения является ли символ цифрой
function NO_DIGIT_SYMBOL( s ) 
{
	try
	{
		if( s!= "0" && s!= "1" && s!= "2" && s!= "3" && s!= "4" && 
			 s!= "5" && s!= "6" && s!= "7" && s!= "8" && s!= "9") return true;
	} catch( error ) {};
	return false;
};// end NO_DIGIT_SYMBOL
//
// подпрограмма получения ссылки на файл данных
function GET_INI_FILE_REF()
{
	INI_ERR = false;
	try
	{
		// получаем ссылку на файл скрипта
		SCRIPT_FILE = File(app.activeScript);
		// получаем адрес папки со скриптом
		SCRIPT_FOLDER = SCRIPT_FILE.path;
		// получаем ссылку на файл настроек
		INI_FILE = File( SCRIPT_FOLDER + "/"+ the_title +".ini" );
	}
	catch ( error ) 
	{
		INI_ERR = true;
	};// try-catch
	return;
};// end GET_INI_FILE_REF
// 
// подпрограмма чтения начальных значений из файла
function INI_READ()
{
	// получаем ссылку на файл скрипта
	GET_INI_FILE_REF();
	if( !INI_ERR )
	{
		// существует ли он
		INI_EXISTS = INI_FILE.exists;
		// если существует считываем значения из него
		if( INI_EXISTS )
		{
			try
			{
				FILE_IO( false );
			} catch ( error ) { };// try-catch
		};// if
	};// if
	return;
};// end INI_READ
//
// подпрограмма записи начальных значений в файл
function INI_WRITE()
{
	// существует ли файл (на всякий случай еще раз)
	INI_EXISTS = INI_FILE.exists;
	// если не существует, пытаемся создать
	if( !INI_EXISTS ) 
	{
		try
		{
			 // получаем ссылку на файл скрипта
			 GET_INI_FILE_REF();
			 if( INI_ERR ) return;
		} catch ( error ) { };
	};// if
	try
	{
		FILE_IO( true );
	} catch ( error ) {};
	return;
};// end INI_WRITE
//
// подпрограмма проверки данных при чтении/записи
function BAD_DATA( x )
{ 
	if( isNaN(parseFloat(x)) || x == undefined ) return true;
	return false;
};// end BAD_DATA
//
// подпрограмма чтения/записи в файл данных (настроек)
// n = true запись
// n = false чтение
function FILE_IO( n )
{
	INI_ERR = false;
	// массив данных для чтения
	var r = new Array();
	// массив данных для записи
	var w = new Array();
	//
	// подпрограмма чтения начального значения из файла данных
	function READ( var_type, ok_cond, val_if_err )
	// var_type: тип переменной (real, integer, logical)
	// ok_cond: допустимый диапазон
	// val_if_err: значение, присваиваемое в случае ошибки
	{
		// ошибка чтения
		var read_err = false;
		// перменная
		var A;
		// пытаемся прочитать из файла
		try
		{
			A = INI_FILE.readln();
		} 
		catch ( error) { read_err = true };
		if( read_err ) return val_if_err;
		// пытаемся перевести прочитанный текст в число
		try
		{
			// вещественное число
			if( var_type == "real" )
			{
				try
				{
					A = parseFloat( A );
					if( isNaN( A ) ) read_err = true;
				} 
				catch ( error) { read_err = true };
			};// if real
			// целое число
			if( var_type == "integer" )
			{
				try
				{
					A = parseInt( A );
					if( isNaN( A ) ) read_err = true;
				} 
				catch ( error) { read_err = true };
			};// if integer
			// логическое значение
			if( var_type == "logical" )
			{
				try
				{
					A = parseInt( A );
					if( isNaN( A ) ) read_err = true;
				} 
				catch ( error) { read_err = true };
			};// if integer
		} catch ( error) { read_err = true };
		if( read_err ) return val_if_err;
		// проверяем по допустимому диапазону
		// вещественное число
		if( var_type == "real" )
		{
			if( (ok_cond == ">0") && !(A>0.) ) return val_if_err;
			if( (ok_cond == ">=0") && !(A>=0.) ) return val_if_err;
			if( (ok_cond == ">1") && !(A>1.) ) return val_if_err;
			if( (ok_cond == ">=1") && !(A>=1.) ) return val_if_err;
		};// if real
		// целое число
		if( var_type == "integer" )
		{
			if( (ok_cond == ">0") && !(A>0) ) return val_if_err;
			if( (ok_cond == ">=0") && !(A>=0) ) return val_if_err;
			if( (ok_cond == ">1") && !(A>1) ) return val_if_err;
			if( (ok_cond == ">=1") && !(A>=1) ) return val_if_err;
		};// if integer
		// возвращаем значение
		if( var_type == "real" || var_type == "integer" ) return A;
		if( var_type == "logical" )
		{
			if( A == 0 ) return false
			else return true;
		};// if
		return val_if_err; 
	};// end READ
	//
	// подпрограмма записи  значений из диалога в файл данных (настроек)
	function WRITE( var_type, A )
	// var_type: тип переменной (real, integer, logical)
	// A: значение переменной
	{
		if( var_type == "logical" )
		{
			try
			{
				if( A ) A = 1
				else A = 0;
			} catch (error) {};
		};// if
		try
		{
			A = A.toString();
			INI_FILE.writeln( A );
		} catch (error) {};
		return;
	};// end WRITE
	//
	try 
	{
		// если стина, то открываем на запись
		if( n ) 
		{
			INI_FILE.open("w")
			//
			// вкладка FRAMES
			WRITE( "real", W_FINAL );// 1
			WRITE( "real", H_FINAL );// 2
			WRITE( "real", BLEED_T );// 3
			WRITE( "real", BLEED_B );// 4
			WRITE( "real", BLEED_L );// 5
			WRITE( "real", BLEED_R );// 6
						
			WRITE( "integer", N_FRAMES_V );// 7
			WRITE( "integer", N_FRAMES_H );// 8

			WRITE( "integer", ORIENT );// 9
			WRITE( "integer", CHANGE );// 10
			//
			// вкладка GUTTERS
			WRITE( "real", GUTTER_H );// 11
			WRITE( "real", GUTTER_V );// 12
			WRITE( "logical", H_GUT_CENTER );// 13
			WRITE( "logical", V_GUT_CENTER );// 14
			//
			// вкладка CROP MARKS
			WRITE( "logical", DRAW_CROP );// 15
			WRITE( "real", MARKS_SW_NUM_INI);// 16
			WRITE( "integer", MARKS_SW_UNITS );// 17
			WRITE( "logical", WHITE_CONT );// 18
			WRITE( "logical", CROP_IN_GUT );// 19
			WRITE( "logical", ADD_LAYER_INI );// 20
			WRITE( "real", MARKS_LEN_H_INI );// 21
			WRITE( "real", MARKS_LEN_V_INI );// 22
			WRITE( "real", MARKS_OFFS_H_INI );// 23
			WRITE( "real", MARKS_OFFS_V_INI );// 24
			WRITE( "logical", CROP_OUT );// 25
			WRITE( "logical", ADD_BLEED_MARKS ); // 26
			WRITE( "logical", ADD_CENTER_MARKS ); // 27
			WRITE( "integer", ADD_CENTER_MARKS_POS );// 28
			//
			// вкладка MARGINS
			WRITE( "real", MARGIN_T );// 29
			WRITE( "real", MARGIN_B );// 30
			WRITE( "real", MARGIN_L );// 31
			WRITE( "real", MARGIN_R );// 32
			//
			// вкладка UNITS
			WRITE( "integer", UNITS );// 33
			//
			// вкладка GUIDES
			WRITE( "logical", DRAW_GUIDES );// 34
			WRITE( "logical", GUIDES_CROP );// 35
			WRITE( "logical", GUIDES_FULL );// 36
			WRITE( "logical", GUIDES_CENTER );// 37
		}
		// если ложь то открываем на чтение
		else 
		{
			INI_FILE.open("r");
			//
			// вкладка FRAMES
			W_FINAL_INI = READ( "real", ">0", W_FINAL_INI );// 1
			H_FINAL_INI = READ( "real", ">0", H_FINAL_INI );// 2
			
			BLEED_T_INI = READ( "real", ">=0", BLEED_T_INI );// 3
			BLEED_B_INI = READ( "real", ">=0", BLEED_B_INI );// 4
			BLEED_L_INI = READ( "real", ">=0", BLEED_L_INI );// 5
			BLEED_R_INI = READ( "real", ">=0", BLEED_R_INI );// 6

			N_FRAMES_V_INI = READ( "integer", ">=1", N_FRAMES_V_INI );// 7
			N_FRAMES_H_INI = READ( "integer", ">=1", N_FRAMES_H_INI );// 8
			
			ORIENT_INI = READ( "integer", ">=0", ORIENT_INI );// 9
			CHANGE_INI = READ( "integer", ">=0", CHANGE_INI );// 10
			//
			// вкладка GUTTERS
			GUTTER_H_INI = READ( "real", ">=0", GUTTER_H_INI );// 11
			GUTTER_V_INI = READ( "real", ">=0", GUTTER_V_INI );// 12
			H_GUT_CENTER_INI = READ( "logical", "", H_GUT_CENTER_INI );// 13
			V_GUT_CENTER_INI = READ( "logical", "", V_GUT_CENTER_INI );// 14
			//
			// вкладка CROP MARKS
			DRAW_CROP_INI = READ( "logical", "", DRAW_CROP_INI );// 15
			MARKS_SW_NUM_INI = READ( "real", ">=0", MARKS_SW_NUM_INI);// 16
			MARKS_SW_UNITS_INI = READ( "integer", ">=0", MARKS_SW_UNITS_INI );// 17
			WHITE_CONT_INI = READ( "logical", "", WHITE_CONT_INI );// 18
			CROP_IN_GUT_INI = READ( "logical", "", CROP_IN_GUT_INI );// 19
			ADD_LAYER_INI = READ( "logical", "", ADD_LAYER_INI );// 20
			MARKS_LEN_H_INI = READ( "real", ">=0", MARKS_LEN_H_INI );// 21
			MARKS_LEN_V_INI = READ( "real", ">=0", MARKS_LEN_V_INI );// 22
			MARKS_OFFS_H_INI = READ( "real", ">=0", MARKS_OFFS_H_INI );// 23
			MARKS_OFFS_V_INI = READ( "real", ">=0", MARKS_OFFS_V_INI);// 24
			CROP_OUT_INI = READ( "logical", "", CROP_OUT_INI );// 25
			ADD_BLEED_MARKS_INI = READ( "logical", "", ADD_BLEED_MARKS_INI );// 26
			ADD_CENTER_MARKS_INI = READ( "logical", "", ADD_CENTER_MARKS_INI );// 27
			ADD_CENTER_MARKS_POS_INI = READ( "integer", ">=0", ADD_CENTER_MARKS_POS_INI );// 28
			//
			// вкладка MARGINS
			MARGIN_T_INI = READ( "real", ">=0", MARGIN_T_INI );// 29
			MARGIN_B_INI = READ( "real", ">=0", MARGIN_B_INI );// 30
			MARGIN_L_INI = READ( "real", ">=0", MARGIN_L_INI );// 31
			MARGIN_R_INI = READ( "real", ">=0", MARGIN_R_INI );// 32
			//
			// вкладка UNITS
			UNITS_INDEX_INI = READ( "integer", ">=0", UNITS_INDEX_INI );// 33
			//
			// вкладка GUIDES
			DRAW_GUIDES_INI = READ( "logical", "", DRAW_GUIDES_INI );// 34
			GUIDES_CROP_INI = READ( "logical", "", GUIDES_CROP_INI );// 35
			GUIDES_FULL_INI = READ( "logical", "", GUIDES_FULL_INI );// 36
			GUIDES_CENTER = READ( "logical", "", GUIDES_CENTER_INI );// 36
		};// if-else
		// закрываем файл
		INI_FILE.close();
	}
	catch ( error )
	{
		INI_ERR = true;
	};// try-catch
	return;
};// end FILE_IO
//
// подпрограмма присвоения начальных значений
function SET_INI()
{
	W_FINAL_INI = "210";
	H_FINAL_INI = "297";
	BLEED_T_INI = "5";
	BLEED_B_INI = "5";
	BLEED_L_INI = "5";
	BLEED_R_INI = "5";
	GUTTER_H_INI = "0";
	GUTTER_V_INI = "0";
	V_GUT_CENTER_INI = false;
	H_GUT_CENTER_INI = false;
	DRAW_CROP_INI = true;
	WHITE_CONT_INI = true;
	CROP_IN_GUT_INI = false;
	ADD_LAYER_INI = true;
	MARKS_LEN_H_INI = "5";
	MARKS_LEN_V_INI = "5";
	MARKS_OFFS_H_INI = "3";
	MARKS_OFFS_V_INI = "3";
	CROP_OUT_INI = true;
	MARKS_SW_NUM_INI = "0.25";
	MARKS_SW_UNITS_INI = 0;
	N_FRAMES_V_INI = "1";
	N_FRAMES_H_INI = "1";
	MARGIN_T_INI = "0";
	MARGIN_B_INI = "0";
	MARGIN_L_INI = "0";
	MARGIN_R_INI = "0";
	UNITS_INDEX_INI = 4;
	ORIENT_INI = 0;
	CHANGE_INI = 0;
	DRAW_GUIDES_INI = true;
	GUIDES_CROP_INI = true;
	GUIDES_FULL_INI = true;
	GUIDES_CENTER_INI = true;
	ADD_BLEED_MARKS_INI = false;
	ADD_CENTER_MARKS_INI = false;
	ADD_CENTER_MARKS_POS_INI = 0;
	return;
};// end SET_INI
//
// подпрограмма снятия эффектов
function CLEAR_EFFECTS( what )
{
	with( what )
	{
		// рельеф
		try { bevelAndEmbossSettings.applied = false } catch (error) {}; 
		// режим наложения
		try { blendingSettings.blendMode = BlendMode.NORMAL } catch (error) {}; 
		// нет прозрачности
		try { blendingSettings.opacity = 100 } catch (error) {};
		// размывка направленная
		try { directionalFeatherSettings.applied = false } catch (error) {}; 
		// тень
		try { dropShadowSettings.mode = ShadowMode.NONE } catch (error) {}; 
		// размывка "обычная"
		try { featherSettings.mode = FeatherMode.NONE } catch (error) {}; 
		// размывка градиентная
		try { gradientFeatherSettings.applied = false } catch (error) {}; 
		// внутр. сияние
		try { innerGlowSettings.applied = false } catch (error) {}; 
		// внутр. тень
		try { innerShadowSettings.applied = false } catch (error) {}; 
		// внешнее сияние
		try { outerGlowSettings.applied = false } catch (error) {}; 
		// сатин :)))
		try { satinSettings.applied = false } catch (error) {}; 
	};// with
	return;
};// end CLEAR_EFFECTS
//
// подпрограмма окончания скрипта
function the_exit(txt)
{
	if( txt !="") alert(txt);
	exit();
};// end the_exit
//
// основной диалог
function DIALOG_INI()
{
	// проверяем версию
	if( APP_VERSION() < 6 ) 
	{
		the_exit("This script can work in InDesign CS4 or newer versions!");
	};// if
	// устанавливаем режим интерпретации как в CS4 (на всякий случай :)))
	app.scriptPreferences.version = 6;
	// определяем файловую систему
	// WFS = true: Windows
	// WFS = false: Macintosh
	if( File.fs != "Windows" ) WFS = false;
	// устанавливаем начальные значения "по умолчанию"
	SET_INI();
	// считываем начальные значения из файла
	INI_READ();
	var d = new Window('dialog');
	 // заголовок диалога
	d.text = the_title + " v." +the_version;
	d.orientation = 'column';
	d.alignChildren = 'center';
	// создаем панель с закладками
	var the_tab_panel = d.add ("tabbedpanel");
	// ширина панели с закладками
	var the_tab_panel_w = WM(290, 330);
	// высота панели с закладками
	var the_tab_panel_h = 300;
	the_tab_panel.preferredSize = [the_tab_panel_w, the_tab_panel_h];
	// подпрограмма создания закладки
	function MAKE_TAB( where, name )
	{
		var the_tab = where.add('tab', undefined, name);
		the_tab.alignChildren = 'left';
		return the_tab;
	};// end MAKE_TAB
	//
	// начальные текстовые значения для единиц измерения
	var UNITS_TEXT_INI = GET_RULER_UNITS_TEXT_FROM_INDEX( UNITS_INDEX_INI );
	//
	// вкладка для параметров фреймов
	var FRAMES_TAB =  MAKE_TAB( the_tab_panel, "Frames" );
	// ширина панелей во вкладках
	var PAN_WIDTH = the_tab_panel_w;
	// длина названия поля 
	var FIELD_NAME_LEN = WM(44, 50);
	// длина поля для ввода данных
	var DATA_FIELD_LEN = WM(40, 45);
	// длина поля для вывода единиц измерения
	var UNITS_LEN = WM(22, 30);
	//
	// панель ввод обрезного формата фрейма
	var FIN_FRAME_SIZE_PAN = DATA_PANEL( FRAMES_TAB, "Finished (cropped) frame size" );
	// ширина
	var W_FINAL_ERR_MSG = "Finished frame width";
	W_FINAL = IN_DATA_FIELD( FIN_FRAME_SIZE_PAN, "Width:", FIELD_NAME_LEN, W_FINAL_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, W_FINAL_ERR_MSG, ">=0");
	// высота
	var H_FINAL_ERR_MSG = "Finished frame height";
	H_FINAL = IN_DATA_FIELD( FIN_FRAME_SIZE_PAN, "Height:", FIELD_NAME_LEN, H_FINAL_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, H_FINAL_ERR_MSG, ">=0");
	// панель ввода вылетов для фрейма
	var FRAME_BLEEDS = DATA_PANEL( FRAMES_TAB, "Frame bleeds" );
	FRAME_BLEEDS.orientation = 'column';
	FRAME_BLEEDS.alignChildren = 'left';
	// группа для вылетов слева и вверху
	var BLEEDS_LT = FRAME_BLEEDS.add('group');
	BLEEDS_LT.orientation = 'row';
	BLEEDS_LT.alignChildren = 'left';
	// вылеты слева
	var BLEED_L_ERR_MSG = "Frame left bleed value";
	BLEED_L = IN_DATA_FIELD( BLEEDS_LT, "Left: ", FIELD_NAME_LEN, BLEED_L_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, BLEED_L_ERR_MSG, ">=0" );
	// вылеты вверху
	var BLEED_T_ERR_MSG = "Frame top bleed value";
	BLEED_T = IN_DATA_FIELD( BLEEDS_LT, "Top: ", FIELD_NAME_LEN, BLEED_T_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, BLEED_T_ERR_MSG, ">=0" );
	// группа для вылетов справа и снизу
	var BLEEDS_RB = FRAME_BLEEDS.add('group');
	BLEEDS_RB.orientation = 'row';
	BLEEDS_RB.alignChildren = 'left';
	// вылет справа
	var BLEED_R_ERR_MSG = "Frame right bleed value";
	BLEED_R = IN_DATA_FIELD( BLEEDS_RB, "Right: ", FIELD_NAME_LEN, BLEED_R_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, BLEED_R_ERR_MSG, ">=0" );
	// вылет снизу
	var BLEED_B_ERR_MSG = "Frame bottom bleed value";
	BLEED_B = IN_DATA_FIELD( BLEEDS_RB, "Bottom: ", FIELD_NAME_LEN, BLEED_B_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, "Bottom frame bleed value", ">=0" );
	// панель вывода суммарного размера фрейма
	var TOTAL_FRAME_SIZE_PAN = DATA_PANEL( FRAMES_TAB, "Full frame size (including bleeds)" );
	// ширина
	W_TOTAL = OUT_DATA_FIELD( TOTAL_FRAME_SIZE_PAN, "Width:", FIELD_NAME_LEN, " ", DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN );
	// высота
	H_TOTAL = OUT_DATA_FIELD( TOTAL_FRAME_SIZE_PAN, "Height:", FIELD_NAME_LEN, " ", DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN );
	// панель ввода количества фреймов в спуске
	var NUMBER_OF_FRAMES_PAN = DATA_PANEL( FRAMES_TAB, "Number of imposed frames" );
	var N_FRAMES_H_ERR_MSG = "Horizontal frames number";
	N_FRAMES_H = IN_DATA_FIELD( NUMBER_OF_FRAMES_PAN, "Horiz.: ", FIELD_NAME_LEN, N_FRAMES_H_INI, DATA_FIELD_LEN, true, "", UNITS_LEN, N_FRAMES_H_ERR_MSG, ">=1" );
	var N_FRAMES_V_ERR_MSG = "Vertical frames number";
	N_FRAMES_V = IN_DATA_FIELD( NUMBER_OF_FRAMES_PAN, "Vertical: ", FIELD_NAME_LEN, N_FRAMES_V_INI, DATA_FIELD_LEN, true, "", UNITS_LEN, N_FRAMES_V_ERR_MSG, ">=1" );
	// панель выбора ориентации фреймов
	var ORIENT_PAN = DATA_PANEL( FRAMES_TAB, "Orientation of frames" );
	ORIENT_PAN.orientation = 'column';
	var ORIENT_TEXT_LEN = WM(175, 195);
	var ORIENT_DATA_LEN = WM(75, 90);
	// направление головы опорного фрейма
	ORIENT = IN_DATA_DROP( ORIENT_PAN, "", ORIENT_TEXT_LEN, ["Up","Right", "Down", "Left"], ORIENT_DATA_LEN, ORIENT_INI );
	ORIENT_TEXT = ORIENT[1];
	ORIENT = ORIENT[0];
	ORIENT.onChange = DOC_SIZE;
	// выбор смены ориентации фреймов в спуске
	var CHANGE_TEXT_LEN = WM(155, 180);
	var CHANGE_DATA_LEN = WM(95, 105);
	CHANGE = IN_DATA_DROP( ORIENT_PAN, "Layout of additional frames:", CHANGE_TEXT_LEN, ["No change", "Change head and foot"], CHANGE_DATA_LEN, CHANGE_INI );
	CHANGE = CHANGE[0];
	CHANGE.onChange = DOC_SIZE;
	//
	// вкладка для промежутков
	var GUT_CENTER_LEN = WM(123, 145);
	var GUTTERS_TAB = the_tab_panel.add ( 'tab', undefined, "Gutters");
	var GUTTERS_PAN = DATA_PANEL( GUTTERS_TAB, "Gutters between frames edges" );
	// ввод промежутков по горизонтали
	var GUT_H_GROUP = GUTTERS_PAN.add('group');
	GUT_H_GROUP.orientation = 'column';
	GUT_H_GROUP.alignChildren = 'left';
	var GUTTER_H_ERR_MSG = "Value of horizontal gutters";
	GUTTER_H = IN_DATA_FIELD( GUT_H_GROUP, "Horiz.: ", FIELD_NAME_LEN, GUTTER_H_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, GUTTER_H_ERR_MSG, ">=0" );
	H_GUT_CENTER = IN_CB( GUT_H_GROUP, "Central horiz. only", GUT_CENTER_LEN, H_GUT_CENTER_INI);
	H_GUT_CENTER.onClick = DOC_SIZE;
	// ввод промежутков по вертикали
	var GUT_V_GROUP = GUTTERS_PAN.add('group');
	GUT_V_GROUP.orientation = 'column';
	GUT_V_GROUP.alignChildren = 'left';
	var GUTTER_V_ERR_MSG = "Value of vertical gutters";
	GUTTER_V = IN_DATA_FIELD( GUT_V_GROUP, "Vertical: ", FIELD_NAME_LEN, GUTTER_V_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, GUTTER_V_ERR_MSG, ">=0" );
	V_GUT_CENTER = IN_CB( GUT_V_GROUP, "Central vertical only", GUT_CENTER_LEN+3, V_GUT_CENTER_INI);
	V_GUT_CENTER.onClick = DOC_SIZE;
	//
	// вкладка для меток
	var MARKS_TAB = the_tab_panel.add ( 'tab', undefined, "Crop marks");
	MARKS_TAB.orientation = 'column';
	MARKS_TAB.alignChildren = 'left';
	var CROP_CB_LEN = WM(250, 280);
	// строить ли метки вообще
	DRAW_CROP = IN_CB( MARKS_TAB, "Draw crop marks", CROP_CB_LEN, DRAW_CROP_INI);
	DRAW_CROP.onClick = DRAW_CROP_ON_CLICK;
	// ввод толщины линии для меток
	var MARKS_W_GROUP = MARKS_TAB.add('group');
	MARKS_W_GROUP.orientation = 'row';
	MARKS_W_GROUP.alignChildren = 'left';
	// длина текста для ввода толщины меток
	var MARKS_W_NUM_TEXT_LEN = WM(150, 170);
	// длина поля ввода толщины меток
	var MARKS_W_NUM_DATA_LEN = WM(60, 57);
	var MARKS_SW_TEXT = MARKS_W_GROUP.add('statictext');
	MARKS_SW_TEXT.preferredSize.width = MARKS_W_NUM_TEXT_LEN;
	var CM_SW_TXT = "Crop marks stroke weight";
	MARKS_SW_TEXT.text = CM_SW_TXT+":";
	var MARKS_SW_NUM_ERR_MSG = CM_SW_TXT;
	MARKS_SW_NUM = MARKS_W_GROUP.add('edittext');
	MARKS_SW_NUM.preferredSize.width = MARKS_W_NUM_DATA_LEN;
	MARKS_SW_NUM.text = MARKS_SW_NUM_INI;
	// подпрограмма реакции на ввод толщины меток
	MARKS_SW_NUM.onChanging = function()
	{
		digit_on_Changing( MARKS_SW_NUM , MARKS_SW_NUM_INI, "0");
		if( TEXT_TO_DIGIT( MARKS_SW_NUM.text ) < 0. )
		{
			alert(MARKS_SW_NUM_ERR_MSG+" must be > 0 !");
			MARKS_SW_NUM.text = MARKS_SW_NUM_INI;
		};// if
		return;
	};// end MARKS_SW_NUM.onChanging
	// выбор единиц измерения для толщины метки
	var MARKS_SW_UNITS_DROP = MARKS_W_GROUP.add('dropdownlist');
	var UN_DROP_LEN = WM(50, 67);
	MARKS_SW_UNITS_DROP.minimumSize.width = MARKS_SW_UNITS_DROP.maximumSize.width =  UN_DROP_LEN;
	MARKS_SW_UNITS_DROP.add('item', "pt");
	MARKS_SW_UNITS_DROP.add('item', "in");
	MARKS_SW_UNITS_DROP.add('item', "mm");
	MARKS_SW_UNITS_DROP.add('item', "cm");
	MARKS_SW_UNITS_DROP.selection = MARKS_SW_UNITS_INI;
	// панель ввода длины меток
	var MARKS_LEN_PAN = DATA_PANEL( MARKS_TAB, "Length of crop marks" );
	var MARKS_LEN_GROUP = MARKS_LEN_PAN.add('group');
	MARKS_LEN_GROUP.orientation = 'column';
	MARKS_LEN_GROUP.alignChildren = 'left';
	var MARKS_LEN_IN= MARKS_LEN_GROUP.add('group');
	MARKS_LEN_IN.orientation = 'row';
	MARKS_LEN_IN.alignChildren = 'left';
	// длина горизонтальных меток
	var MARKS_LEN_H_ERR_MSG = "Length of horizontal crop marks";
	MARKS_LEN_H = IN_DATA_FIELD( MARKS_LEN_IN, "Horiz.: ", FIELD_NAME_LEN, MARKS_LEN_H_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, MARKS_LEN_H_ERR_MSG , ">=0" );
	// длина вертикальных меток
	var MARKS_LEN_V_ERR_MSG = "Length of vertical crop marks";
	MARKS_LEN_V = IN_DATA_FIELD( MARKS_LEN_IN, "Vertical: ", FIELD_NAME_LEN, MARKS_LEN_V_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, MARKS_LEN_V_ERR_MSG, ">=0" );
	// панель ввода отступа меток от фреймов
	var OFFS_PAN_TEXT = "Offset";
	var OFFS_PAN_TEXT_FULL_SIZE = " from full size of frame";
	var OFFS_PAN_TEXT_FIN_SIZE = " from finished size of frame";
	var OFFS_PAN_TEXT_INI = "";
	// начальный текст в названии пенели
	if( CROP_OUT_INI ) OFFS_PAN_TEXT_INI = OFFS_PAN_TEXT + OFFS_PAN_TEXT_FULL_SIZE
	else OFFS_PAN_TEXT_INI = OFFS_PAN_TEXT + OFFS_PAN_TEXT_FIN_SIZE;
	var MARKS_OFFS_PAN = DATA_PANEL( MARKS_TAB, OFFS_PAN_TEXT_INI );
	var MARKS_OFFS_GROUP = MARKS_OFFS_PAN.add('group');
	MARKS_OFFS_GROUP.orientation = 'column';
	MARKS_OFFS_GROUP.alignChildren = 'left';
	var MARKS_OFFS_IN= MARKS_OFFS_GROUP.add('group');
	MARKS_OFFS_IN.orientation = 'row';
	MARKS_OFFS_IN.alignChildren = 'left';
	// горизонтальный отступ
	var MARKS_OFFS_H_ERR_MSG = "Value of horizontal crop marks offset";
	MARKS_OFFS_H = IN_DATA_FIELD( MARKS_OFFS_IN, "Horiz.: ", FIELD_NAME_LEN, MARKS_OFFS_H_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, MARKS_OFFS_H_ERR_MSG, ">=0" );
	// вертикальный отступ
	var MARKS_OFFS_V_ERR_MSG = "Value of vertical crop marks offset";
	MARKS_OFFS_V = IN_DATA_FIELD( MARKS_OFFS_IN, "Vertical: ", FIELD_NAME_LEN, MARKS_OFFS_V_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, MARKS_OFFS_V_ERR_MSG, ">=0" );
	// ставить внешние метки метки вне фреймов
	CROP_OUT = IN_CB( MARKS_TAB, "Draw crop marks outside of frames", CROP_CB_LEN, CROP_OUT_INI);
	// подпрограмма реакции на смену положения меток (вне фреймов или по обрезному формату)
	CROP_OUT.onClick = function()
	{
		if( CROP_OUT.value ) MARKS_OFFS_PAN.text = OFFS_PAN_TEXT + OFFS_PAN_TEXT_FULL_SIZE
		else MARKS_OFFS_PAN.text = OFFS_PAN_TEXT + OFFS_PAN_TEXT_FIN_SIZE;
		DOC_SIZE();
		return;
	};// end CROP_OUT.onClick
	// добавлять ли метки по полному формату (по вылетам)
	ADD_BLEED_MARKS = IN_CB( MARKS_TAB, "Draw bleed marks", CROP_CB_LEN, ADD_BLEED_MARKS_INI);
	// добавлять ли метки в промежутках
	ADD_CENTER_MARKS_GROUP = MARKS_TAB.add('group');
	ADD_CENTER_MARKS_GROUP.orientation = 'row';
	ADD_CENTER_MARKS_GROUP.alignChildren = 'left';
	var add_cm_len = WM( 122, 143 )
	ADD_CENTER_MARKS = IN_CB( ADD_CENTER_MARKS_GROUP, "Draw central marks", add_cm_len, ADD_CENTER_MARKS_INI);
	var add_cm_pos_len = WM( 95, 110 );
	var add_cm_pos_text_len = WM( 50, 55 );
	ADD_CENTER_MARKS_POS = IN_DATA_DROP( ADD_CENTER_MARKS_GROUP, "between", add_cm_pos_text_len, ["Crop marks", "Frames edges"], add_cm_pos_len, ADD_CENTER_MARKS_POS_INI );
	ADD_CENTER_MARKS.onClick = function()
	{
		ADD_CENTER_MARKS_POS_VISIBLE();
		return;
	};// end ADD_CENTER_MARKS
	function ADD_CENTER_MARKS_POS_VISIBLE()
	{
		ADD_CENTER_MARKS_POS[0].visible = 
		ADD_CENTER_MARKS_POS[1].visible = 
		ADD_CENTER_MARKS.value;
		if( !ADD_CENTER_MARKS_GROUP.visible )
		{
			ADD_CENTER_MARKS_POS[0].visible = 
			ADD_CENTER_MARKS_POS[1].visible = false;
		};// if
		return;
	};// end ADD_CENTER_MARKS_POS_VISIBLE
	ADD_CENTER_MARKS_POS_VISIBLE();
	// делать ли белый контур вокруг метки
	WHITE_CONT = IN_CB( MARKS_TAB, "White contour around mark", CROP_CB_LEN, WHITE_CONT_INI);
	// создавать ли дополнительный слой для меток
	ADD_LAYER = IN_CB( MARKS_TAB, "Create additional layer for marks", CROP_CB_LEN, ADD_LAYER_INI);
	// строить ли метки в промежутках
	CROP_IN_GUT = IN_CB( MARKS_TAB, "Draw marks between frames (if possible)", CROP_CB_LEN, CROP_IN_GUT_INI);
	// начальные параметры ввода для меток
	// самое главное: видны ли они вообще :)))
	MARKS_W_GROUP.visible = MARKS_LEN_PAN.visible = MARKS_OFFS_PAN.visible =
	WHITE_CONT.visible = CROP_IN_GUT.visible = ADD_LAYER.visible = CROP_OUT.visible =
	ADD_BLEED_MARKS.visible = ADD_CENTER_MARKS_GROUP.visible = DRAW_CROP_INI;
	// подпрограмма реакции на вкл.-выкл. построения меток
	function DRAW_CROP_ON_CLICK()
	{
		MARKS_W_GROUP.visible = 
		MARKS_LEN_PAN.visible = 
		MARKS_OFFS_PAN.visible =
		WHITE_CONT.visible =
		CROP_IN_GUT.visible =
		ADD_LAYER.visible =
		CROP_OUT.visible =
		ADD_BLEED_MARKS.visible =
		ADD_CENTER_MARKS_GROUP.visible =
		DRAW_CROP.value;
		DOC_SIZE();
		return;
	};// end DRAW_CROP_ON_CLICK
	//
	// вкладка для дополнительных вылетов документа
	// вне меток и/или фреймов
	var MARG_TAB = MAKE_TAB( the_tab_panel, "Margins");
	// панель для ввода дополнительных вылетов документа
	var MARG_PAN = DATA_PANEL( MARG_TAB, "Additional margins outside of imposition" );
	MARG_PAN.orientation = 'column';
	MARG_PAN.alignChildren = 'left';
	var MARG_NAME_LEN = WM(44, 44);
	// группа для вылетов слева и вверху
	var MARG_LT = MARG_PAN.add('group');
	MARG_LT.orientation = 'row';
	MARG_LT.alignChildren = 'left';
	// вылет слева
	var MARGIN_L_ERR_MSG = "Left margin value";
	MARGIN_L = IN_DATA_FIELD( MARG_LT, "Left: ", FIELD_NAME_LEN, MARGIN_L_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, MARGIN_L_ERR_MSG, ">=0" );
	// вылет вверху
	var MARGIN_T_ERR_MSG = "Top margin value";
	MARGIN_T = IN_DATA_FIELD( MARG_LT, "Top: ", FIELD_NAME_LEN, MARGIN_T_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, MARGIN_T_ERR_MSG, ">=0" );
	// группа для вылетов справа и снизу
	var MARG_RB = MARG_PAN.add('group');
	MARG_RB.orientation = 'row';
	MARG_RB.alignChildren = 'left';
	// вылет справа
	var MARGIN_R_ERR_MSG = "Right margin value";
	MARGIN_R = IN_DATA_FIELD( MARG_RB, "Right: ", FIELD_NAME_LEN, MARGIN_R_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, MARGIN_R_ERR_MSG, ">=0" );
	// вылет снизу
	var MARGIN_B_ERR_MSG = "Bottom margin value";
	MARGIN_B = IN_DATA_FIELD( MARG_RB, "Bottom: ", FIELD_NAME_LEN, MARGIN_B_INI, DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN, MARGIN_B_ERR_MSG, ">=0" );
	//
	// вкладка для выбора единиц измерения для нового документа
	var UNITS_TAB = MAKE_TAB( the_tab_panel, "Units" );
	// панель ввода единиц измерения для нового документа
	var UNITS_PAN = DATA_PANEL( UNITS_TAB, "Measurement units for new document" );
	UNITS_PAN.orientation = 'row';
	UNITS = UNITS_PAN.add('dropdownlist');
	UNITS.add('item', "Points (pt)");
	UNITS.add('item', "Picas (pc)");
	UNITS.add('item', "Inches (in)");
	UNITS.add('item', "Inches decimal (ind)");
	UNITS.add('item', "Millimeters (mm)");
	UNITS.add('item', "Centimeters (cm)");
	UNITS.add('item', "Ciceros (ci)");
	UNITS.add('item', "Agates (ag)");
	UNITS.selection = UNITS_INDEX_INI;
	UNITS.onChange = CHANGE_UNITS;
	var SPACE_UN = UNITS_PAN.add('statictext');
	SPACE_UN.text = "";
	var SPACE_UN_LEN = 10;
	SPACE_UN.preferredSize.width = SPACE_UN_LEN;
	//
	// вкладка для направляющих
	var GUIDES_TAB = MAKE_TAB( the_tab_panel, "Guides" );
	// строить ли направляющие вообще
	DRAW_GUIDES = IN_CB( GUIDES_TAB, "Draw guides", CROP_CB_LEN, DRAW_GUIDES_INI);
	// строить по обрезному формату
	GUIDES_CROP = IN_CB( GUIDES_TAB, "Guides for finished size", CROP_CB_LEN, GUIDES_CROP_INI);
	// строить по полному формату (с вылетами)
	GUIDES_FULL = IN_CB( GUIDES_TAB, "Guides for full size", CROP_CB_LEN, GUIDES_FULL_INI);
	// строить ли в центре
	GUIDES_CENTER = IN_CB( GUIDES_TAB, "Guides for centers", CROP_CB_LEN, GUIDES_CENTER_INI);
	// подпрограмма реакции на команду построения направляющих
	// по обрезному формату, полному формату, по центрам
	GUIDES_CROP.onClick = GUIDES_FULL.onClick = GUIDES_CENTER.onClick = function()
	{
		if( !GUIDES_CROP.value && !GUIDES_FULL.value && !GUIDES_CENTER.value)
		{
			GUIDES_CROP.visible = GUIDES_FULL.visible = GUIDES_CENTER.visible =
			DRAW_GUIDES.value = false;
		};// if
		return;
	};// end GUIDES_CROP.onClick, GUIDES_FULL.onClick, GUIDES_CENTER.onClick
	if( !DRAW_GUIDES.value )
	{
		GUIDES_CENTER.visible = GUIDES_CROP.visible = GUIDES_FULL.visible = false;
	};// if
	DRAW_GUIDES.onClick = DRAW_GUIDES_ON_CLICK;
	// подпрограмма реакции на команду построения направляющих
	function DRAW_GUIDES_ON_CLICK()
	{
		if( !DRAW_GUIDES.value )
		{
			GUIDES_CENTER.visible = GUIDES_CROP.visible = GUIDES_FULL.visible = false;
		}
		else
		{
			GUIDES_CENTER.visible = GUIDES_CENTER.value =
			GUIDES_CROP.visible = GUIDES_FULL.visible = 
			GUIDES_CROP.value = GUIDES_FULL.value = true;
		};// if-else
		return;
	};// end DRAW_GUIDES_ON_CLICK
	//
	// панель для вывода размеров нового документа
	var SIZE_PAN = d.add('panel');
	SIZE_PAN.text = "Size of new document for imposition";
	SIZE_PAN.orientation = 'row';
	SIZE_PAN.alignChildren = 'left';
	SIZE_PAN.preferredSize = [the_tab_panel_w+WM(23, 15), 40];
	DOC_DATA_FIELD_LEN = WM(55, 59);
	DOC_W_NAME_LEN = WM(35, 40);
	DOC_H_NAME_LEN = WM(40, 45);
	// ширина
	DOC_W = OUT_DATA_FIELD( SIZE_PAN, "Width:", DOC_W_NAME_LEN, " ", DOC_DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN );
	// высота
	DOC_H = OUT_DATA_FIELD( SIZE_PAN, "Height:", DOC_H_NAME_LEN, " ", DOC_DATA_FIELD_LEN, true, UNITS_TEXT_INI, UNITS_LEN );
	// подпрограмма смены единиц измерения в диалоге по одному направлению
	function CHANGE_UNITS_TEXT( the_arr, the_text )
	{
		for( var i=0; i < the_arr.length; i++ )
		{
			the_arr[i].text = the_text;
		};// for		
		return;
	};// end  CHANGE_UNITS
	//
	// подпрограмма смены едининиц измерения по горизонтали
	function CHANGE_UNITS()
	{
		var UNITS_TEXT = GET_RULER_UNITS_TEXT_FROM_INDEX( UNITS.selection.index );
		CHANGE_UNITS_TEXT( [H_FINAL[1], BLEED_T[1], BLEED_B[1], H_TOTAL[1], GUTTER_V[1], MARKS_LEN_V[1], MARKS_OFFS_V[1], MARGIN_T[1], MARGIN_B[1], DOC_H[1] ], UNITS_TEXT );
		CHANGE_UNITS_TEXT( [W_FINAL[1], BLEED_L[1], BLEED_R[1],  W_TOTAL[1], GUTTER_H[1], MARKS_LEN_H[1], MARKS_OFFS_H[1], MARGIN_L[1], MARGIN_R[1], DOC_W[1] ],  UNITS_TEXT );
		return;
	};// end CHANGE_UNITS
	//
	// подпрограмма определения размеров документа
	function DOC_SIZE()
	{
		// подпрограмма расчета размера по одному измерению (высота или ширина)
		function DOC_DIM( FR_FIN_SIZE, FR_N, GUT_SIZE, GUT_CENTER, CROP_LEN_1, CROP_LEN_2, MARG_1, MARG_2, OFFS_1, OFFS_2 )
		{
			var CL = CROP_LEN_1 + CROP_LEN_2;
			if( !DRAW_CROP.value )
			{
				CL = OFFS_1 = OFFS_2 = 0.
			};// if
			// число промежутков
			var NG = FR_N - 1;
			//
			// если только один фрейм по направлению то промежутков нет :)))
			// ввод величины промежутков запрещен
			if( NG <= 0 )
			{ 
				GUT_SIZE.text = "0";
				GUT_SIZE.enabled = false;
				GS = 0.;
			}
			// если больше одного фрейма по направлению 
			// то ввод величины промежутков разрешен
			else
			{
				GUT_SIZE.enabled = true;
			};// if-else
			// ввод только центрального промежутка
			// если НЕразрешен ввод величины промежутка
			if( !GUT_SIZE.enabled ) 
			{
				// запрещаем ввод центрального промежктка
				GUT_CENTER.enabled = GUT_CENTER.value = false;
			}
			// если разрешен ввод величины промежутка
			else
			{
				// если число промежутков нечетное
				if( IS_ODD ( NG ) ) 
				{
					// если величина промежутка больше 0
					if(TEXT_TO_DIGIT( GUT_SIZE.text ) > 0.) 
					{
						GUT_CENTER.enabled = true;
					}
					else
					{
						GUT_CENTER.enabled = GUT_CENTER.value = false;
					};// if-else
				}
				else 
				{
					GUT_CENTER.enabled = GUT_CENTER.value = false;
				};// if-else
			};// if-else
			// коэффициент для количества промежутков
			var K_GUT = NG;
			// если только строится центральный промежуток
			if( GUT_CENTER.value ) 
			{
				K_GUT = 1.;
			}
			// общая величина промежутков
			var GS = TEXT_TO_DIGIT( GUT_SIZE.text ) * K_GUT;
			// рассчитываем полный размер спуска по направлению
			var D = 
			// полный размер фрейма
			FR_FIN_SIZE *
			// количество фреймов по направлению
			FR_N +
			// общая величина промежутков
			GS +
			// длина меток
			CL +
			// отступы меток
			OFFS_1 + OFFS_2 +
			// дополнительные поля
			TEXT_TO_DIGIT( MARG_1.text ) + TEXT_TO_DIGIT( MARG_2.text );
			return D;
		};// end DOC_DIM
		//
		// количество фреймов
		var NF_H = TEXT_TO_DIGIT( N_FRAMES_H[0].text );// по горизонтали
		var NF_V = TEXT_TO_DIGIT( N_FRAMES_V[0].text );// по вертикали
		// текущее значение ориентации
		// 0=Top 1=Right 2=Bottom 3=Left
		var ORIENT_VAL = ORIENT.selection.index;
		//
		if( NF_H == 1 && NF_V == 1 )
		{
			CHANGE.selection = 0;
			CHANGE.enabled = false;
			ORIENT_TEXT.text = "Frame's head faces:";
		}
		else
		{
			if( NF_H == 1 && NF_V > 1 ) 
			{
				ORIENT_TEXT.text = "Lower frame's head faces:";
				if(ORIENT_VAL == 1 || ORIENT_VAL == 3 )
				{
					CHANGE.enabled = false;
					CHANGE.selection = 0;
				}
				else
				{
					if( !CHANGE.enabled ) CHANGE.enabled = true;
				};// if -else
			};// if
			if( NF_H > 1 && NF_V == 1 ) 
			{
				ORIENT_TEXT.text = "Left frame's head faces:";
				if(ORIENT_VAL == 0 || ORIENT_VAL == 2 )
				{
					CHANGE.enabled = false;
					CHANGE.selection = 0;
				}
				else
				{
					if( !CHANGE.enabled ) CHANGE.enabled = true;
				};// if -else
			};// if
			if( NF_H > 1 && NF_V > 1 ) 
			{
				ORIENT_TEXT.text = "Lower left frame's head faces:";
				if( !CHANGE.enabled ) CHANGE.enabled = true;
			};// if
		};// if-else
		//
		ORIENT_VAL = ORIENT.selection.index;
		// учитываем реальные вылеты с учетом поворота фрейма
		// если фреймы повернуты вверх
		if( ORIENT_VAL == 0 )
		{
			BLEED_T_VAL = TEXT_TO_DIGIT( BLEED_T[0].text );
			BLEED_B_VAL = TEXT_TO_DIGIT( BLEED_B[0].text );
			BLEED_L_VAL = TEXT_TO_DIGIT( BLEED_L[0].text );
			BLEED_R_VAL = TEXT_TO_DIGIT( BLEED_R[0].text );
		};// if
		// если фреймы повернуты вправо
		if( ORIENT_VAL == 1 )
		{
			BLEED_T_VAL = TEXT_TO_DIGIT( BLEED_L[0].text );
			BLEED_B_VAL = TEXT_TO_DIGIT( BLEED_R[0].text );
			BLEED_L_VAL = TEXT_TO_DIGIT( BLEED_B[0].text );
			BLEED_R_VAL = TEXT_TO_DIGIT( BLEED_T[0].text );
		};// if
		// если фреймы повернуты вниз
		if(ORIENT_VAL == 2 )
		{
			BLEED_T_VAL = TEXT_TO_DIGIT( BLEED_B[0].text );
			BLEED_B_VAL = TEXT_TO_DIGIT( BLEED_T[0].text );
			BLEED_L_VAL = TEXT_TO_DIGIT( BLEED_R[0].text );
			BLEED_R_VAL = TEXT_TO_DIGIT( BLEED_L[0].text );
		};// if
		// если фреймы повернуты влево
		if( ORIENT_VAL == 3 )
		{
			BLEED_T_VAL = TEXT_TO_DIGIT( BLEED_R[0].text );
			BLEED_B_VAL = TEXT_TO_DIGIT( BLEED_L[0].text );
			BLEED_L_VAL = TEXT_TO_DIGIT( BLEED_T[0].text );
			BLEED_R_VAL = TEXT_TO_DIGIT( BLEED_B[0].text );
		};// if
		// высота фрейма
		var H = TEXT_TO_DIGIT( H_FINAL[0].text ) + BLEED_T_VAL + BLEED_B_VAL;
		// ширина фрейма
		var W = TEXT_TO_DIGIT( W_FINAL[0].text ) + BLEED_L_VAL + BLEED_R_VAL;
		// учитываем поврот фреймов при расчете ширины и высоты
		if( ORIENT.selection.index == 1 || ORIENT.selection.index == 3 )
		{
			H = TEXT_TO_DIGIT( W_FINAL[0].text ) + BLEED_T_VAL + BLEED_B_VAL;
			W = TEXT_TO_DIGIT( H_FINAL[0].text ) + BLEED_R_VAL + BLEED_L_VAL;
		};// if
		// выводим полный размер фрейма в панели полного размера
		H_TOTAL[0].text = H.toString();
		W_TOTAL[0].text = W.toString();
		//
		// чекбокс меток в промежутках неактивен если нет только один фрейм 
		if( NF_V < 2 && NF_H < 2 )
		{
			CROP_IN_GUT.enabled = CROP_IN_GUT.value = false;
			ADD_CENTER_MARKS.enabled = ADD_CENTER_MARKS.value = false;
			ADD_CENTER_MARKS_POS_VISIBLE ();
		}
		else
		{
			if(  !CROP_IN_GUT.enabled )
			{
				CROP_IN_GUT.enabled = true;
				CROP_IN_GUT.value = CROP_IN_GUT_INI;
			};// if
			if(  !ADD_CENTER_MARKS.enabled )
			{
				ADD_CENTER_MARKS.enabled = true;
				ADD_CENTER_MARKS.value = ADD_CENTER_MARKS_INI;
				ADD_CENTER_MARKS_POS_VISIBLE ();
			};// if
		};// if-else
		//
		// длины меток
		// верх
		MARKS_LEN_V_T = TEXT_TO_DIGIT( MARKS_LEN_V[0].text );
		// низ
		MARKS_LEN_V_B = MARKS_LEN_V_T;
		// слева
		MARKS_LEN_H_L = TEXT_TO_DIGIT( MARKS_LEN_H[0].text );
		// справа
		MARKS_LEN_H_R = MARKS_LEN_H_L;
		// проверка для длин меток: если = 0, тогда неактивны отступы
		// по вертикали
		if( MARKS_LEN_V_T == 0. )
		{
			MARKS_OFFS_V[0].text = "0";
			MARKS_OFFS_V[0].enabled = false;
		}
		else
		{
			if( !MARKS_OFFS_V[0].enabled )
			{
				MARKS_OFFS_V[0].enabled = true;
				MARKS_OFFS_V[0].text = MARKS_OFFS_V_INI;
			};// if
		};// if-else
		//по горизонтали
		if( MARKS_LEN_H_L == 0. )
		{
			MARKS_OFFS_H[0].text = "0";
			MARKS_OFFS_H[0].enabled = false;
		}
		else
		{
			if( !MARKS_OFFS_H[0].enabled )
			{
				MARKS_OFFS_H[0].enabled = true;
				MARKS_OFFS_H[0].text = MARKS_OFFS_H_INI;
			};// if
		};// if-else
		// отступы для меток реза
		// верх
		var M_OFFS_V_T = TEXT_TO_DIGIT( MARKS_OFFS_V[0].text );
		// низ
		var M_OFFS_V_B = M_OFFS_V_T;
		// слева
		var M_OFFS_H_L = TEXT_TO_DIGIT( MARKS_OFFS_H[0].text );
		// справа
		var M_OFFS_H_R = M_OFFS_H_L;
		//
		// расчет длин меток вне фреймов
		// если отсчет от обрезного формата
		if( !CROP_OUT.value )
		{
			// слева
			var MARK_PLUS_OFFS_L = M_OFFS_H_L + MARKS_LEN_H_L;
			// если метка + отступ слева меньше вылета слева
			if( MARK_PLUS_OFFS_L <= BLEED_L_VAL )
			{
				// размер слева определяется только вылетом фрейма
				// длина метки и отступ слева не учитываются
				MARKS_LEN_H_L = 0.;
			}
			// если метка + отступ слева больше вылета слева
			else
			{
				// из суммы длины метки и отступа слева слева вычитается вылет слева
				MARKS_LEN_H_L = (MARKS_LEN_H_L +  M_OFFS_H_L ) - BLEED_L_VAL;
			};// if
			// справа
			var MARK_PLUS_OFFS_R = M_OFFS_H_R + MARKS_LEN_H_R;
			// если метка + отступ справа меньше вылета справа
			if( MARK_PLUS_OFFS_R <= BLEED_R_VAL )
			{
				// размер справа определяется только вылетом фрейма
				// длина метки и отступ справа не учитываются
				MARKS_LEN_H_R = 0.;
			}
			// если метка + отступ справа больше вылета справа
			else
			{
				// из суммы длины метки и отступа справа слева вычитается вылет справа
				MARKS_LEN_H_R = ( MARKS_LEN_H_R + M_OFFS_H_R ) - BLEED_R_VAL;
			};// if
			// вверху
			var MARK_PLUS_OFFS_T = M_OFFS_V_T + MARKS_LEN_V_T;
			// если метка + отступ вверху меньше вылета вверху
			if( MARK_PLUS_OFFS_T <= BLEED_T_VAL )
			{
				// размер вверху определяется только вылетом фрейма
				// длина метки и отступ вверху не учитываются
				MARKS_LEN_V_T = 0.;
			}
			// если метка + отступ вверху больше вылета вверху
			else
			{
				// из суммы длины метки и отступа вверху слева вычитается вылет вверху
				MARKS_LEN_V_T = ( MARKS_LEN_V_T + M_OFFS_V_T ) - BLEED_T_VAL;
			};// if
			// внизу
			// если метка + отступ вверху меньше вылета внизу
			var MARK_PLUS_OFFS_B = M_OFFS_V_B + MARKS_LEN_V_B;
			// если метка + отступ внизу меньше вылета внизу
			if( MARK_PLUS_OFFS_B <= BLEED_B_VAL )
			{
				// размер внизу определяется только вылетом фрейма
				// длина метки и отступ внизу не учитываются
				MARKS_LEN_V_B = 0.;
			}
			// если метка + отступ внизу больше вылета внизу
			else
			{
				// из суммы длины метки и отступа внизу слева вычитается вылет внизу
				MARKS_LEN_V_B = ( MARKS_LEN_V_B + M_OFFS_V_B ) - BLEED_B_VAL;
			};// if
			// обнуляем отступы для случая обрезного формата для построения меток
			M_OFFS_V_B = M_OFFS_V_T = M_OFFS_H_R = M_OFFS_H_L = 0.
			// проверяем случай если при повороте с разных сторон оказываются
			// одноименные грани фрейма
			// значение для смены ориентации
			// 0=No Change 1=Change
			// текущее значение для смены ориентации
			var CHANGE_VAL = CHANGE.selection.index;
			// проверка по горизонтали
			// если четное число фреймов по горизонтали и задана смена ориентации
			if( !IS_ODD( NF_H ) && CHANGE_VAL == 1)
			{
				// если голова нижнего левого фрейма вправо
				if( ORIENT_VAL == 1)
				{
					MARKS_LEN_H_R = MARKS_LEN_H_L;
				};// if
				// если голова нижнего левого фрейма влево
				if( ORIENT_VAL == 3 )
				{
					MARKS_LEN_H_R = MARKS_LEN_H_L;
				};// if				
			};// if
			// проверка по вертикали
			// если четное число фреймов по вертикали и задана смена ориентации
			if( !IS_ODD( NF_V ) && CHANGE_VAL == 1)
			{
				// если голова нижнего левого фрейма вверх
				if( ORIENT_VAL == 0) 
				{
					MARKS_LEN_V_T = MARKS_LEN_V_B;
				};// if
				// если голова нижнего левого фрейма вниз
				if( ORIENT_VAL == 2 ) 
				{
					MARKS_LEN_V_T = MARKS_LEN_V_B;
				};// if
			};// if
		};// if !CROP_OUT.value
		// вывод в диалоге размера документа
		// высота документа
		DOC_H[0].text  = 
		DOC_DIM
		( 
			H, // высота фрейма
			NF_V, // число фреймов по вертикали
			GUTTER_V[0],  // выличина промежутков между фреймами по вертикали
			V_GUT_CENTER, // только центральный промежуток по вертикали
			MARKS_LEN_V_T, // реальная длина меток вверху спуска
			MARKS_LEN_V_B, // реальная длина меток внизу спуска
			MARGIN_T[0],  // поле документа верху
			MARGIN_B[0], // поле документа внизу
			M_OFFS_V_T, // отступ для меток вверху
			M_OFFS_V_B // отступ для меток внизу
		);
		// ширина документа
		DOC_W[0].text = 
		DOC_DIM
		( 
			W, // ширина фрейма
			NF_H, // число фреймов по горизонтали
			GUTTER_H[0], // выличина промежутков между фреймами по горизонтали
			H_GUT_CENTER, // только центральный промежуток по горизонтали
			MARKS_LEN_H_L, // реальная длина меток слева спуска
			MARKS_LEN_H_R, // реальная длина меток справа спуска
			MARGIN_L[0],   // поле документа слева
			MARGIN_R[0],  // поле документа справа
			M_OFFS_H_L, // отступ для меток слева
			M_OFFS_H_R // отступ для меток справа
		);
		return;
	};// end DOC_SIZE
	//
	// подпрограмма создания поля ввода числа в диалоге
	function IN_DATA_FIELD( where, name, name_len, ini_data, data_len, un, un_text, un_len, bad_val_msg, condit )
	{
		var the_line = where.add('group');
		// создаем строку
		the_line.orientation = 'row';
		the_line.alignChildren = 'left';
		// название
		var the_name = the_line.add('statictext');
		the_name.text = name;
		the_name.preferredSize.width = name_len;
		// поле ввода
		var data_field = the_line.add('edittext');
		data_field.text = ini_data;
		data_field.preferredSize.width = data_len;
		data_field.onChanging = et_on_Changing;
		// подпрограмма реакции на ввод
		function et_on_Changing()
		{
			digit_on_Changing(data_field, ini_data, "0");
			var data_val = TEXT_TO_DIGIT( data_field.text );
			// проверка введенного числа по заданному условию
			// если диапазон строго > 0
			if( condit == ">0" )
			{
				if( data_val <= 0. )
				{
					alert(bad_val_msg+" must be > 0 !");
					data_field.text = ini_data;
				};// if
			};// if ">0"
			// если диапазон  >= 1
			if( condit == ">=1" )
			{
				if( data_val < 1 )
				{
					alert(bad_val_msg+" must be >= 1 !");
					data_field.text = ini_data;
				};// if
				if( NON_INTEGER( data_val ) )
				{
					alert(bad_val_msg+" must be integer!");
					data_field.text = parseInt( data_val ).toString();
				};// if
			};// if ">=1"
			// если диапазон >= 0
			if( condit == ">=0" )
			{
				if( data_val < 0. )
				{
					alert(bad_val_msg+" must be >= 0 !");
					data_field.text = ini_data;
				};// if
			};// if ">=0"
			// обновляем значения в диалоге
			DOC_SIZE();
		};// end  et_on_Changing
		// вывод единиц
		var the_units;
		if( un != false )
		{
			the_units = the_line.add('statictext');
			the_units.text = un_text;
			the_units.preferredSize.width = un_len;
		};// if
		return [data_field, the_units];		
	};// end IN_DATA_FIELD
	//
	// подпрограмма создания поля для вывода числа в диалоге
	function OUT_DATA_FIELD( where, name, name_len, ini_data, data_len, un, un_text, un_len )
	{
		var the_line = where.add('group');
		// создаем строку
		the_line.orientation = 'row';
		the_line.alignChildren = 'left';
		// название
		var the_name = the_line.add('statictext');
		the_name.text = name;
		the_name.preferredSize.width = name_len;
		// поле ввода
		var data_field = the_line.add('statictext');
		data_field.text = ini_data;
		data_field.preferredSize.width = data_len;
		// вывод единиц
		if( un )
		{
			var the_units = the_line.add('statictext');
			the_units.text = un_text;
			the_units.preferredSize.width = un_len;
		};// if
		return [data_field, the_units];		
	};// end OUT_DATA_FIELD
	//
	// подпрограмма создания выпадающего списка (дропдауна) в диалоге
	function IN_DATA_DROP( where, name, name_len, data_arr, data_len, data_ini )
	{
		var the_line = where.add('group');
		// создаем строку
		the_line.orientation = 'row';
		the_line.alignChildren = 'left';
		// название
		var the_name = the_line.add('statictext');
		the_name.text = name;
		the_name.preferredSize.width = name_len;
		// создаем дропдаун
		var dr = the_line.add('dropdownlist');
		for( var i=0; i < data_arr.length; i++ )
		{
			dr.add( 'item', data_arr[i] );
		};// for
		dr.minimumSize.width =
		dr.maximumSize.width =  data_len;
		dr.selection = data_ini;
		return [dr, the_name];
	};// end IN_DATA_DROP
	//
	// подпрограмма создания чекбокса в диалоге
	function IN_CB( where, name, len, ini)
	{
		var cb = where.add('checkbox');
		cb.text = name;
		cb.value = ini;
		cb.preferredSize.width = len;
		return cb;
	};// end IN_CB
	//
	// подпрограмма создания панели (с рамкой) для ввода данных в диалоге
	function DATA_PANEL( where, txt )
	{
		var the_pan = where.add('panel');
		the_pan.orientation = 'row';
		the_pan.alignChildren = 'left';
		the_pan.text = txt;
		the_pan.minimumSize.width = the_pan.maximumSize.width =  PAN_WIDTH;
		return the_pan;
	};// end DATA_PANEL
	// начальный вызов подпрограммы вывода размеров
	DOC_SIZE();
	// группа кнопок запуска (остановки) скрипта
	var OK_GROUP = d.add ('group');
	OK_GROUP.add ('button', undefined, "Make imposition", {name: "ok"});
	OK_GROUP.add ('button', undefined, "Cancel");
	// вывод диалога
	var DIALOG_BUTTON = d.show ();
	// если нажата вторая кнопка = Cancel
	if (DIALOG_BUTTON == 2) 
	{
		the_exit("");
	};// if
	// если нажата НЕ вторая кнопка = Make imposition :)
	// получаем данные из диалога
	//
	// обрезной формат фрейма
	H_FINAL = IN_VAL( H_FINAL[0].text, ">0", H_FINAL_ERR_MSG );
	W_FINAL = IN_VAL( W_FINAL[0].text, ">0", W_FINAL_ERR_MSG );
	// вылеты для фрейма
	BLEED_L = IN_VAL( BLEED_L[0].text, ">=0", BLEED_L_ERR_MSG );
	BLEED_R = IN_VAL( BLEED_R[0].text, ">=0", BLEED_R_ERR_MSG );
	BLEED_T = IN_VAL( BLEED_T[0].text, ">=0", BLEED_T_ERR_MSG );
	BLEED_B = IN_VAL( BLEED_B[0].text, ">=0", BLEED_B_ERR_MSG );
	// размеры документа
	DOC_H =  IN_VAL( DOC_H[0].text, "", "" );
	DOC_W = IN_VAL( DOC_W[0].text, "", "" );
	// число фреймов
	N_FRAMES_H =  IN_VAL( N_FRAMES_H[0].text, ">=1", N_FRAMES_H_ERR_MSG );
	N_FRAMES_V =  IN_VAL( N_FRAMES_V[0].text, ">=1", N_FRAMES_V_ERR_MSG );
	// ориентация головы левго нижнего фрейма
	ORIENT = ORIENT.selection.index;
	// смена положения фреймов
	CHANGE = CHANGE.selection.index;
	// промежутки между фрймами
	GUTTER_H = IN_VAL( GUTTER_H[0].text, ">=0", GUTTER_H_ERR_MSG );
	GUTTER_V = IN_VAL( GUTTER_V[0].text, ">=0", GUTTER_V_ERR_MSG );
	// только один промежуток
	V_GUT_CENTER = V_GUT_CENTER.value;
	H_GUT_CENTER = H_GUT_CENTER.value;
	if( IS_ODD( N_FRAMES_V ) ) V_GUT_CENTER = false;
	if( IS_ODD( N_FRAMES_H ) ) H_GUT_CENTER = false;
	// метки реза
	// делать ли вообще
	DRAW_CROP = DRAW_CROP.value;
	// толщина меток реза
	MARKS_SW_NUM = IN_VAL( MARKS_SW_NUM.text, ">=0", MARKS_SW_NUM_ERR_MSG );
	// единицы для толщины меток реза
	MARKS_SW_UNITS = MARKS_SW_UNITS_DROP.selection.index;
	// длина меток реза
	MARKS_LEN_H = IN_VAL( MARKS_LEN_H[0].text, ">=0", MARKS_LEN_H_ERR_MSG );
	MARKS_LEN_V = IN_VAL( MARKS_LEN_V[0].text, ">=0", MARKS_LEN_V_ERR_MSG );
	// величина отступов для меток реза
	MARKS_OFFS_H = IN_VAL( MARKS_OFFS_H[0].text, ">=0", MARKS_OFFS_H_ERR_MSG );
	MARKS_OFFS_V = IN_VAL( MARKS_OFFS_V[0].text, ">=0", MARKS_OFFS_V_ERR_MSG );
	// ставить внешние метки метки вне фреймов
	CROP_OUT = CROP_OUT.value;
	// создавать ли белый контур вокруг меток реза
	WHITE_CONT = WHITE_CONT.value;
	// создавать ли новый слой для меток реза
	ADD_LAYER = ADD_LAYER.value;
	// создавать ли метки реза в промежутках
	CROP_IN_GUT = CROP_IN_GUT.value;
	// добавлять ли метки по полному формату
	ADD_BLEED_MARKS = ADD_BLEED_MARKS.value;
	// добавлять ли центральные метки
	ADD_CENTER_MARKS = ADD_CENTER_MARKS.value;
	ADD_CENTER_MARKS_POS = ADD_CENTER_MARKS_POS[0].selection.index;
	// дополнительные поля документа
	MARGIN_L = IN_VAL( MARGIN_L[0].text, ">=0", MARGIN_L_ERR_MSG );
	MARGIN_T = IN_VAL( MARGIN_T[0].text, ">=0", MARGIN_T_ERR_MSG );
	MARGIN_R = IN_VAL( MARGIN_R[0].text, ">=0", MARGIN_R_ERR_MSG );
	MARGIN_B = IN_VAL( MARGIN_B[0].text, ">=0", MARGIN_B_ERR_MSG );
	// единицы измерения для нового документа
	UNITS = UNITS.selection.index;
	// создание направляющих
	DRAW_GUIDES = DRAW_GUIDES.value;
	GUIDES_CROP = GUIDES_CROP.value;
	GUIDES_FULL = GUIDES_FULL.value;
	// вывод сообщение об ошибках ввода (если они есть)
	SHOW_ERR_MSG();
	// вывод предупреждений
	SHOW_WARN_MSG();
	// собственно выполнение операции
	OPERATION();
	// записываем данные из диалога
	INI_WRITE();
	return;
};// end DIALOG_INI
//
// подпрограмма вывода предупреждений
// о значениях в диалоге
function SHOW_WARN_MSG()
{
	if( !DRAW_CROP ) return;
	var S = "Dialog input warnings:\n\n";
	var WRITE = false;
	var W_1 = false;
	var W_2 = false;
	// если по нулям длины меток реза сразу по вертикали и горизонтали
	if( MARKS_LEN_H == 0. && MARKS_LEN_V == 0. )
	{
		S = S + 
		"Lengths of horizontal and vertical crop marks = 0 !\n";
		W_1 = WRITE = true;
	};// if
	// если толщина меток реза = 0
	if( MARKS_SW_NUM == 0. )
	{
		S = S + 
		"Stroke weight of crop marks = 0 !\n";
		W_2 = WRITE = true;
	};// if
	if( W_1 || W_2 )
	{
		S = S + "Crop marks will be not drawn!\n";
	};// if
	if( WRITE )
	{
		S = S + "\nContinue?";
		if( !confirm( S ) ) exit();
	};// if
	return;
};// end SHOW_WARN_MSG
//
// подпрограмма вывода сообщений об ошибках ввода в диалоге
function SHOW_ERR_MSG()
{
	var N_ERR = BAD_VAL_MSG_ARR.length;
	if( N_ERR > 0 )
	{
		var S = "Dialog input errors:\n\n";
		for( var i=0; i < N_ERR; i++ )
		{
			S = S + BAD_VAL_MSG_ARR[i] ;
		};// for
		alert( S );
		exit();
	};// if
	return;
};// end SHOW_ERR_MSG
//
// подпрограмма контроля и преобразования введенных данных
function IN_VAL( data_text, cond_ok, msg )
{
	var OK = true;
	var val = TEXT_TO_DIGIT( data_text );
	if( cond_ok == ">=0" ) if( !( val >= 0. ) )  {OK = false; msg = msg+" must be >= 0"};
	if( cond_ok == ">0" )   if( !( val > 0. ) )     {OK = false; msg = msg+" must be > 0"};
	if( cond_ok == ">=1" )   if( !( val >= 1 ) ) {OK = false; msg = msg+" must be >= 1"};
	//
	if( !OK )
	{
		BAD_VAL_MSG_ARR.push( msg+"\n" );
	};// if
	return val;
};// end IN_VAL
//
// подпрограмма проверки является ли число целым
function NON_INTEGER( A )
{
	var INT = parseInt( A );
	if( ( Math.abs(A) - Math.abs(INT) ) != 0. ) return true;
	return false;
};// end NON_INTEGER
//
// подпрограмма определения текстового значения единиц из индекса
function GET_RULER_UNITS_TEXT_FROM_INDEX(N) 
{
	switch ( N ) 
	{
		case ( 0 ): return "pt";// points
		case ( 1 ): return "pc";// picas
		case ( 2 ): return "in";// inches
		case ( 3 ): return "ind";// inches decimal
		case ( 4 ): return "mm";
		case ( 5 ): return "cm";
		case ( 6 ): return "ci";// ciceros
		case ( 7 ): return "ag";// agates
		default: return "mm";// mm if error
	};// switch
	return "??";
};// end GET_RULER_UNITS_TEXT_FROM_INDEX;
//
// подпрограмма определения единиц из индекса
function GET_RULER_UNITS_FROM_INDEX(N) 
{
	switch ( N ) 
	{
		case ( 0 ): return 2054188905;// points
		case ( 1 ): return 2054187363;// picas
		case ( 2 ): return 2053729891;// inches
		case ( 3 ): return 2053729892;// inches decimal
		case ( 4 ): return 2053991795;// mm
		case ( 5 ): return 2053336435;// cm
		case ( 6 ): return 2053335395;// ciceros
		case ( 7 ): return 2051106676;// agates
		default: return 2053991795;// mm if error
	};// switch
	return 2053991795;
};// end GET_RULER_UNITS_FROM_INDEX;
//
// подпрограмма выполнения операции
function OPERATION()
{
	// создание документа
	CREATE_DOC();
	// создание фреймов
	ADD_FRAMES();
	// создание меток
	ADD_CROPS();
	return;
};// end OPERATION
//
// подпрограмма построения меток реза
function ADD_CROPS()
{
	// подпрограмма добавления объекта в массив
	function PUSH( arr, obj )
	{
		// не добавляем если объект = false
		if( obj == false ) return;
		// добавляем
		arr.push( obj )
		return;
	};// end PUSH
	//
	// функция перевода числа в пункты
	function TO_POINTS ( x ) 
	{
		var k = 1.;
		if( MARKS_SW_UNITS == 0 ) k = 1.; 
		if( MARKS_SW_UNITS == 1 ) k = 72.; 
		if( MARKS_SW_UNITS == 2 ) k = (72./25.4); 
		if( MARKS_SW_UNITS == 3 ) k = ((72./25.4)*10.);
		return x * k;
	};// end TO_POINTS
	//
	// подпрограмма перемещения копий элементов массива
	function MOVE_COPY_ARR( the_arr, X, Y )
	{
		// массив копий
		var arr_copy = new Array();
		for( var i=0; i < the_arr.length; i++ )
		{
			// создаем копию элемента
			var the_obj = the_arr[i].duplicate();
			// перемещаем копию
			var the_copy = MOVE( the_obj, X, Y );
			// добавляем копию в массив
			arr_copy.push( the_copy );
		};// for
		// на выходе массив перемещенных копий
		return arr_copy;
	};// end MOVE_COPY_ARR
	//
	// подпрограмма добавления одного массива к другому
	function ADD_ARR( arr_1, arr_2 )
	{
		var arr_3 = new Array();
		arr_3 = arr_1;
		for( var i=0; i < arr_2.length; i++ )
		{
			arr_3.push( arr_2[i] );
		};// for
		return arr_3;
	};// end ADD_ARR;
	//
	// строим ли горизонтальные метки
	var MAKE_CROP_H = true;
	// если длина меток по горизонтали = 0, тогда метки по горизонтали не строим
	if( MARKS_LEN_H == 0. ) MAKE_CROP_H = false;
	// строим ли вертикальные метки
	var MAKE_CROP_V = true;
	// если длина меток по вертикали = 0, тогда метки по вертикали не строим
	if( MARKS_LEN_V == 0. ) MAKE_CROP_V = false;
	// строим ли метки вообще
	// если одновременно =0 все длины меток или толщина метки =0
	if( (!MAKE_CROP_V && !MAKE_CROP_H) || MARKS_SW_NUM == 0. ) 
	{
		// тогда не строим метки и не создаем новый слой
		DRAW_CROP = ADD_LAYER = false;
	};// if
	// если не строим метки 
	if( !DRAW_CROP )
	{
		// тогда не строим метки по вертикали и по горизонтали :)))
		MAKE_CROP_V = MAKE_CROP_H = false;
	}
	// если все-таки строим метки
	else
	{
		// переводим введенную толщину линии в пункты
		MARKS_SW_NUM_INI = MARKS_SW_NUM;
		MARKS_SW_NUM = TO_POINTS ( MARKS_SW_NUM );
	};// if-else
	// массивы уже сделанных меток
	// все метки
	var ALL_MARKS = new Array();
	// метки слева
	var LEFT_MARKS = new Array();
	// метки справа
	var RIGHT_MARKS = new Array();
	// метки снизу
	var BOTTOM_MARKS = new Array();
	// метки вверху
	var TOP_MARKS = new Array();
	// массивы координат уже сделанных направляющих
	// для вертикальных направляющих
	var MADE_X = new Array();
	// для горизонтальных направляющих
	var MADE_Y = new Array();
	// мастера для направляющих
	// для вертикальных направляющих
	var GUIDE_V_MASTER, GUIDE_V_MASTER_MADE = false;
	// для горизонтальных направляющих
	var GUIDE_H_MASTER, GUIDE_H_MASTER_MADE = false;
	// включаем показ направляющих если было задано их построение
	if( DRAW_GUIDES )
	{
		try
		{
			AD.guidePreferences.guidesShown = true;
		} 
		catch ( error ) {};// try-catch
	};// if
	// границы фреймов
	var the_frame_left, the_frame_right, the_frame_top, the_frame_bottom;
	//
	// подпрограмма получения геометрических границ фрейма
	function get_geometric_bounds( f )
	{
		var the_frame_bounds = GET_FRAME_BOUNDS ( f );
		the_frame_left = the_frame_bounds[0];
		the_frame_right = the_frame_bounds[2];
		the_frame_top = the_frame_bounds[1];
		the_frame_bottom = the_frame_bounds[3];
		return;
	};// end get_geometric_bounds
	//
	// подпрограмма получения вылетов фрейма в зависимости
	// от ориентации (угла поворота)
	function GET_BLEED( the_orient )
	{
		// голова фрейма вверх
		if( (the_orient == 0.) || (the_orient == 360.) || (the_orient == -360.) ) 
		{
			return [ BLEED_T,  BLEED_L,  BLEED_B,  BLEED_R ];
		};// if
		// голова фрейма вниз
		if( (the_orient == 180.) || (the_orient == -180.) ) 
		{
			return [ BLEED_B,  BLEED_R,  BLEED_T,  BLEED_L ];
		};// if
		// голова фрейма вправо
		if( (the_orient == -90.) || (the_orient == 270.) )  
		{
			return [ BLEED_L,  BLEED_B,  BLEED_R,  BLEED_T ];
		};// if
		// голова фрейма влево
		if( (the_orient == 90.) || (the_orient == -270.) )  
		{
			return [ BLEED_R,  BLEED_T,  BLEED_L,  BLEED_B ];
		};// if
	};// end GET_BLEED_TB
	//
	// смещения меток относительно обрезного формата
	var DL = BLEED_L_VAL;// слева
	var DR = BLEED_R_VAL;// справа
	var DT = BLEED_T_VAL;// вверху
	var DB = BLEED_B_VAL;// внизу
	// меняем ли вылеты в рядах
	// по горизонтали
	var CHANGE_BLEED_H = false;
	if( (ORIENT == 1 || ORIENT == 3 ) && CHANGE )
	{
		CHANGE_BLEED_H = true;
	};// if
	// по вертикали
	var CHANGE_BLEED_V = false;
	if( (ORIENT == 0 || ORIENT == 2 ) && CHANGE )
	{
		CHANGE_BLEED_V = true;
	};// if
	// подпрограмма создания вертикальной метки реза
	function MAKE_CROP_MARK_V( the_mark, the_top, the_bottom, the_x, crop, guide)
	{
		if( crop && MAKE_CROP_V )
		{
			the_mark = MAKE_MARK_VER( the_top, the_bottom, the_x );
			PUSH( ALL_MARKS, the_mark ); PUSH( BOTTOM_MARKS, the_mark );
		};// if
		if( guide && DRAW_GUIDES ) make_vertical_guide( the_x );
		return;
	};// end MAKE_CROP_MARK_V
	//
	// метки по нижнему ряду фреймов
	// метки по обрезному формату
	var mark_bottom_1;// левая
	var mark_bottom_2;// правая
	// метки по полному формату
	var mark_bottom_3;// левая
	var mark_bottom_4;// правая
	// центральная вертикальная метка
	var mark_bottom_5;
	// начальное положение меток внизу
	// (самый низ меток внизу)
	var DY_B = BLEED_B_VAL;
	if( CROP_OUT ) DY_B = 0.;
	// цикл по нижнему ряду фреймов
	for( var i = 0; i < bottom_frames.length; i++ )
	{
		// геометрические границы текущего фрейма
		get_geometric_bounds( bottom_frames[i] )
		// вылеты текущего фрейма с учетом ориентации
		var bleeds_i = GET_BLEED( bottom_frames_orient[i] );
		// левый вылет
		var DX_B_1 = bleeds_i[1];
		// правый вылет
		var DX_B_2 = bleeds_i[3];
		// если создаются вертикальные метки
		// сначала строим ряд меток внизу
		// верхняя координата нижних меток
		var MB_T = (the_frame_bottom - DY_B)  + MARKS_OFFS_V;
		// нижняя координата нижних меток
		var MB_B = MB_T + MARKS_LEN_V;
		// первая вертикальная метка (обрезной формат левая)
		MAKE_CROP_MARK_V( mark_bottom_1, MB_T, MB_B, the_frame_left + DX_B_1, DRAW_CROP, GUIDES_CROP);
		// вторая вертикальная метка (обрезной формат правая)
		MAKE_CROP_MARK_V( mark_bottom_2, MB_T, MB_B, the_frame_right - DX_B_2, DRAW_CROP, GUIDES_CROP);
		// третья вертикальная метка (полный формат левая)
		MAKE_CROP_MARK_V( mark_bottom_3, MB_T, MB_B, the_frame_left, ADD_BLEED_MARKS, GUIDES_FULL);
		// четвертая вертикальная метка (полный формат правая)
		MAKE_CROP_MARK_V( mark_bottom_4, MB_T, MB_B, the_frame_right, ADD_BLEED_MARKS, GUIDES_FULL);
		// если добавляются цетральные метки 
		if( i < bottom_frames.length - 1 )
		{
			// если между метками
			if( ADD_CENTER_MARKS_POS == 0 )
			{
				// левая координата 
				var mark_bottom_5_left = the_frame_right - DX_B_2;
				// следующий фрейм
				var next_frame = bottom_frames[i+1];
				// вылеты следующего фрейма
				var bleeds_next = GET_BLEED( bottom_frames_orient[i+1] );
				// левый вылет следующего фрейма
				var bleed_next_left = bleeds_next[1];
				// границы следующего фрейма
				get_geometric_bounds( next_frame );
				// правая координата
				var mark_bottom_5_right = the_frame_left + bleed_next_left;
			}
			// если между фреймами
			else
			{
				// левая координата
				var mark_bottom_5_left = the_frame_right;
				// следующий фрейм
				var next_frame = bottom_frames[i+1];
				// границы следующего фрейма
				get_geometric_bounds( next_frame );
				// правая координата
				var mark_bottom_5_right = the_frame_left;
			};// if-else
			// центр между горизонтальными координатами (лево - право)
			var mark_bottom_5_center = mark_bottom_5_left  + ( mark_bottom_5_right - mark_bottom_5_left )/2.;
			// пятая вертикальная метка (центральная)
			MAKE_CROP_MARK_V( mark_bottom_5, MB_T, MB_B, mark_bottom_5_center, ADD_CENTER_MARKS, GUIDES_CENTER);
		};// if
	};// for
	//
	// если создаются вертикальные метки
	// ряд меток внизу уже построен, строим метки вверху
	if( MAKE_CROP_V )
	{
		// поправка по вертикали при смене ориентации
		var DY_T = BLEED_T_VAL;
		if( CHANGE_BLEED_V )
		{
			// если четное число фреймов по вертикали
			if( !IS_ODD( N_FRAMES_V ) )
			{
				DY_T = BLEED_B_VAL;
			};// if
		};// if
		if( CROP_OUT ) DY_T = 0.;
		// нижняя граница верхней метки
		// учитываем возможный только один вертикальный промежуток
		var K_GUT_V = N_GUT_V;
		if( V_GUT_CENTER ) K_GUT_V = 1;
		// нижняя координата верхних меток
		var MT_B = 
		the_frame_bottom - 
		(
		H_FULL // высота фрейма
		* N_FRAMES_V // число фреймов по вертикали
		+ GUTTER_V // величина промутка между фреймами по вертикали
		* K_GUT_V // число промежутков
		) 
		+ DY_T
		- MARKS_OFFS_V;
		// собственно перемещение по вертикали (по оси Y)
		var MR_DY = MT_B - MB_B;
		// перемещаем копию массива нижних меток вверх
		TOP_MARKS = MOVE_COPY_ARR( BOTTOM_MARKS, 0., MR_DY );
		ADD_ARR ( ALL_MARKS, TOP_MARKS );
	};// if
	//
	// подпрограмма создания горизонтальной метки реза
	function MAKE_CROP_MARK_H( the_mark, the_left, the_right, the_y, crop, guide)
	{
		if( crop && MAKE_CROP_H )
		{
			the_mark = MAKE_MARK_HOR( the_left, the_right, the_y );
			PUSH( ALL_MARKS, the_mark ); PUSH( LEFT_MARKS, the_mark );
		};// if
		if( guide && DRAW_GUIDES ) make_horizontal_guide( the_y );
		return;
	};// end MAKE_CROP_MARK_H
	//
	// метки по левому ряду фреймов
	// метки по обрезному формату
	var mark_left_1;// верхняя
	var mark_left_2;// нижняя
	// метки по полному формату
	var mark_left_3;// верхняя
	var mark_left_4;// нижняя
	// центральная горизонтальная метка
	var mark_left_5;
	// крайнее левое положение меток слева
	var DX_L = BLEED_L_VAL;
	if( CROP_OUT ) DX_L = 0.;
	// цикл по левому ряду фреймов
	for( var i = left_frames.length-1; i >= 0; i-- )
	{
		// геометрические границы текущего фрейма
		get_geometric_bounds( left_frames[i] );
		// вылеты текущего фрейма с учетом ориентации
		var bleeds_i = GET_BLEED( left_frames_orient[i] );
		// верхний вылет
		var DY_L_1 = bleeds_i[0];
		// нижний вылет
		var DY_L_2 = bleeds_i[2];
		// если создаются горизонтальные метки
		// сначала строим ряд меток слева
		// правая координата левых меток
		var ML_R = (the_frame_left + DX_L)  - MARKS_OFFS_H;
		// левая координата левых меток
		var ML_L = ML_R - MARKS_LEN_H;
		// первая горизонтальная метка (обрезной формат верхняя)
		MAKE_CROP_MARK_H( mark_left_1, ML_L, ML_R, the_frame_top + DY_L_1, DRAW_CROP, GUIDES_CROP);
		// вторая горизонтальная метка (обрезной формат нижняя)
		MAKE_CROP_MARK_H( mark_left_2, ML_L, ML_R, the_frame_bottom - DY_L_2, DRAW_CROP, GUIDES_CROP);
		// третья горизонтальная метка (полный формат верхняя)
		MAKE_CROP_MARK_H( mark_left_3, ML_L, ML_R, the_frame_top, ADD_BLEED_MARKS, GUIDES_FULL);
		// четвертая горизонтальная метка (полный формат нижняя)
		MAKE_CROP_MARK_H( mark_left_4, ML_L, ML_R, the_frame_bottom, ADD_BLEED_MARKS, GUIDES_FULL);
		// если добавляются цетральные метки 
		if( i > 0 )
		{
			// если между метками
			if( ADD_CENTER_MARKS_POS == 0 )
			{
				// нижняя координата
				var mark_left_5_bottom = the_frame_top + DY_L_1;
				// следующий фрейм
				var next_frame = left_frames[i-1];
				// вылеты следующего фрейма
				var bleeds_next = GET_BLEED( left_frames_orient[i-1] );
				// нижний вылет следующего фрейма
				var bleed_next_bottom = bleeds_next[2];
				// границы следующего фрейма
				get_geometric_bounds( next_frame );
				// верхняя координата
				var mark_left_5_top = the_frame_bottom - bleed_next_bottom;
			}
			// если между фреймами
			else
			{
				// нижняя координата
				var mark_left_5_bottom = the_frame_top;
				// следующий фрейм
				var next_frame = left_frames[i-1];
				// границы следующего фрейма
				get_geometric_bounds( next_frame );
				// верхняя координата
				var mark_left_5_top = the_frame_bottom;
			};// if-else
			// центр между вертикальными координатами (верх - низ)
			var mark_left_5_center = mark_left_5_top  + ( mark_left_5_bottom - mark_left_5_top )/2.;
			// пятая горизонтальная метка (центральная)
			MAKE_CROP_MARK_H( mark_left_5, ML_L, ML_R, mark_left_5_center, ADD_CENTER_MARKS, GUIDES_CENTER);
		};// if
	};// for
	// если создаются горизонтальные метки
	// метки слева уже построены, строим метки справа
	if( MAKE_CROP_H )
	{
		// поправка по горизонтали при смене ориентации
		var DX_R = BLEED_R_VAL;
		if( CHANGE_BLEED_H )
		{
			// четное число фреймов по горизонтали
			if( !IS_ODD( N_FRAMES_H ) )
			{
				DX_R = BLEED_L_VAL;
			};// if
		};// if
		if( CROP_OUT ) DX_R = 0.;
		// учитываем возможный только один горизонтальный промежуток
		var K_GUT_H = N_GUT_H;
		if( H_GUT_CENTER ) K_GUT_H = 1;
		// левая граница правой метки
		var MR_L = 
		the_frame_left +
		(
		W_FULL // ширина фрейма
		* N_FRAMES_H // число фреймов по горизонтали
		+ GUTTER_H // величина промутка между фреймами по горизонтали
		* K_GUT_H // число промежутков
		) 
		- DX_R
		+ MARKS_OFFS_H;
		// собственно перемещение по горизонтали (ось Х)
		var MR_DX = MR_L - ML_L;
		// перемещаем копию массива левых меток направо
		RIGHT_MARKS = MOVE_COPY_ARR( LEFT_MARKS, MR_DX, 0. );
		ADD_ARR ( ALL_MARKS, RIGHT_MARKS );
	};// if
	//
	// если задано построение меток в промежутках
	if( CROP_IN_GUT )
	{
		// если метки вне фреймов
		if( CROP_OUT )
		{
			// если задано построение вертикальных меток
			// (метки вне фреймов)
			// если строятся вертикальные метки
			if( MAKE_CROP_V )
			{
				// если в вертикальный промежуток помещается хотя бы одна метка
				// с учетом отступов от фреймов тогда строим метки в вертикальных промежутках
				// возможность строить метки в промежутках по вертикали
				var DRAW_BETWEEN_V = false;
				// пространство по вертикали
				var D_GUTTER_V = GUTTER_V - ( MARKS_LEN_V + MARKS_OFFS_V * 2. );
				if( D_GUTTER_V < 0. && (Math.abs( D_GUTTER_V ) <= PREC) ) DRAW_BETWEEN_V = true;
				if( D_GUTTER_V >= 0. ) DRAW_BETWEEN_V = true;
				// если есть место по вертикали
				if( DRAW_BETWEEN_V )
				{
					// начальный центр по вертикали для массива нижних меток
					var CV_START = ( MB_B - (MB_B - MB_T)/2.);
					// начальный индекс для фреймов
					var i_start = left_frames.length-1;
					// конечный индекс для фреймов
					var i_end = 0;
					// если только один промежуток по вертикали
					if( V_GUT_CENTER )
					{
						i_start = N_FRAMES_V/2 ;
						i_end = N_FRAMES_V/2 - 1 ;
					};// if
					// цикл по вертикальным промежуткам
					for( var i = i_start ; i > i_end; i-- )
					{
						// нижний фрейм
						var FRAME_BELOW = left_frames[i];
						get_geometric_bounds( FRAME_BELOW );
						// верхняя граница нижнего фрейма
						var FRAME_BELOW_T = the_frame_top;
						var CV_BELOW = FRAME_BELOW_T - MARKS_OFFS_V - MARKS_LEN_V/2.;
						var DY_GUT_BELOW = CV_BELOW - CV_START;
						var GUT_MARKS_V_B = MOVE_COPY_ARR( BOTTOM_MARKS, 0., DY_GUT_BELOW );
						ADD_ARR ( ALL_MARKS, GUT_MARKS_V_B );
						// если в промежутке есть место для верхних меток
						if( !( GUTTER_V == MARKS_LEN_V + MARKS_OFFS_V * 2. ) )
						{
							// верхний фрейм
							var FRAME_ABOVE = left_frames[i-1];
							get_geometric_bounds( FRAME_ABOVE );
							// нижняя граница верхнего фрейма
							var FRAME_ABOVE_B = the_frame_bottom;
							var CV_ABOVE = FRAME_ABOVE_B + MARKS_OFFS_V + MARKS_LEN_V/2.;
							var DY_GUT_ABOVE = CV_ABOVE - CV_START;
							var GUT_MARKS_V_A = MOVE_COPY_ARR( BOTTOM_MARKS, 0., DY_GUT_ABOVE );
							ADD_ARR ( ALL_MARKS, GUT_MARKS_V_A );
						};// if
					};// for
				};// if				
			};// if
			//
			// если задано построение горизонтальных меток
			// (метки вне фреймов)
			if( MAKE_CROP_H )
			{
				// если в горизонтальный промежуток помещается хотя бы одна метка
				// с учетом отступов от фреймов тогда строим метки в горизонтальных промежутках
				// возможность строить метки в промежутках по горизонтали
				var DRAW_BETWEEN_H = false;
				// пространство по горизонтали
				var D_GUTTER_H = GUTTER_H - ( MARKS_LEN_H + MARKS_OFFS_H * 2. );
				if( D_GUTTER_H < 0. && (Math.abs( D_GUTTER_H ) <= PREC) ) DRAW_BETWEEN_H = true;
				if( D_GUTTER_H >= 0. ) DRAW_BETWEEN_H = true;
				if(DRAW_BETWEEN_H )
				{
					// центр по горизонтали для массива левых меток
					var CH_START = ( ML_L + (ML_R - ML_L)/2.);
					// начальный индекс для фреймов
					var i_start = 0;
					// конечный индекс для фреймов
					var i_end = bottom_frames.length-1;
					// если только один промежуток по горизонтали
					if( H_GUT_CENTER )
					{
						i_start = N_FRAMES_H/2 - 1 ;
						i_end = N_FRAMES_H/2;
					};// if
					// цикл по горизонтальным промежуткам
					for( var i = i_start ; i < i_end; i++ )
					{
						// левый фрейм
						var FRAME_LEFT =bottom_frames[i];
						get_geometric_bounds(  FRAME_LEFT );
						// правая граница левого фрейма
						var FRAME_LEFT_R = the_frame_right;
						var CH_RIGHT =  FRAME_LEFT_R + MARKS_OFFS_H + MARKS_LEN_H/2.;
						var DX_GUT_RIGHT = CH_RIGHT - CH_START;
						var GUT_MARKS_H_R = MOVE_COPY_ARR( LEFT_MARKS, DX_GUT_RIGHT, 0. );
						ADD_ARR ( ALL_MARKS, GUT_MARKS_H_R );
						// если в промежутке есть место для левых меток
						if( !( GUTTER_H == MARKS_LEN_H + MARKS_OFFS_H * 2. ) )
						{
							// правый фрейм
							var FRAME_RIGHT = bottom_frames[i+1];
							get_geometric_bounds( FRAME_RIGHT );
							// левая граница правого фрейма
							var FRAME_RIGHT_L = the_frame_left;
							var CH_LEFT = FRAME_RIGHT_L - MARKS_OFFS_H - MARKS_LEN_H/2.;
							var DX_GUT_LEFT = CH_LEFT - CH_START;
							var GUT_MARKS_H_L = MOVE_COPY_ARR( LEFT_MARKS, DX_GUT_LEFT, 0. );
							ADD_ARR ( ALL_MARKS, GUT_MARKS_H_L );
						};// if
					};// for
				};// if				
			};// if
		}
		else
		// если отступы меток от обрезного формата
		{
			// если задано построение вертикальных меток
			// (метки от обрезного формата)
			if( MAKE_CROP_V )
			{
				// начальный центр по вертикали для массива нижних меток
				var CV_START = ( MB_B - (MB_B - MB_T)/2.);
				// цикл по вертикальным промежуткам
				for( var i = left_frames.length-1 ; i > 0; i-- )
				{
					// нижний фрейм
					var FRAME_BELOW = left_frames[i];
					get_geometric_bounds( FRAME_BELOW );
					// верхняя граница нижнего фрейма
					var FRAME_BELOW_T = the_frame_top;
					// верхний фрейм
					var FRAME_ABOVE = left_frames[i-1];
					get_geometric_bounds( FRAME_ABOVE );
					// нижняя граница верхнего фрейма
					var FRAME_ABOVE_B = the_frame_bottom;
					// определяем вылеты
					// вылет нижнего фрейма
					var FRAME_BELOW_BLEED_TOP = GET_BLEED( left_frames_orient[i] )[0];
					// вылет верхнего фрейма
					var FRAME_ABOVE_BLEED_BOTTOM = GET_BLEED( left_frames_orient[i-1] )[2];
					// определяем высоту пространства для построения меток
					// в текущем вертикальном промежутке
					var GUTTER_V_VAL =
					( FRAME_BELOW_T + FRAME_BELOW_BLEED_TOP - MARKS_OFFS_V ) - 
					( FRAME_ABOVE_B - FRAME_ABOVE_BLEED_BOTTOM + MARKS_OFFS_V );
					// возможность строить метки в данном промежутке по вертикали
					var DRAW_BETWEEN_V = false;
					// пространство по вертикали
					var D_GUTTER_V = GUTTER_V_VAL - MARKS_LEN_V;
					if( D_GUTTER_V < 0. && Math.abs( D_GUTTER_V ) <= PREC ) DRAW_BETWEEN_V = true;
					if( D_GUTTER_V >= 0. ) DRAW_BETWEEN_V = true;
					// если место есть копируем нижние метки
					if( DRAW_BETWEEN_V )
					{
						// центр для нижних меток
						var CV_BELOW = (FRAME_BELOW_T + FRAME_BELOW_BLEED_TOP) - (MARKS_OFFS_V + MARKS_LEN_V/2.);
						// перемещение в нижнюю часть промежутка
						var DY_GUT_BELOW = CV_BELOW - CV_START;
						var GUT_MARKS_V_B = MOVE_COPY_ARR( BOTTOM_MARKS, 0., DY_GUT_BELOW );
						ADD_ARR ( ALL_MARKS, GUT_MARKS_V_B );
						// если в промежутке есть место для верхних меток
						if( !( (GUTTER_V_VAL - MARKS_LEN_V ) <= PREC ) )
						{
							// центр для верхних меток
							var CV_ABOVE = (FRAME_ABOVE_B - FRAME_ABOVE_BLEED_BOTTOM) + (MARKS_OFFS_V + MARKS_LEN_V/2.);
							// перемещение в верхнюю часть промежутка
							var DY_GUT_ABOVE = CV_ABOVE - CV_START;
							var GUT_MARKS_V_A = MOVE_COPY_ARR( BOTTOM_MARKS, 0., DY_GUT_ABOVE );
							ADD_ARR ( ALL_MARKS, GUT_MARKS_V_A );
						};// if
					};// if
				};// for
			};// if
			// если задано построение горизонтальных меток
			// (метки от обрезного формата)
			if( MAKE_CROP_H )
			{
				// центр по горизонтали для массива левых меток
				var CH_START = ( ML_L + (ML_R - ML_L)/2.);
				// цикл по горизонтальным промежуткам
				for( var i = 0 ; i < bottom_frames.length-1; i++ )
				{
					// левый фрейм
					var FRAME_LEFT = bottom_frames[i];
					get_geometric_bounds( FRAME_LEFT );
					// правая граница левого фрейма
					var FRAME_LEFT_R = the_frame_right;
					// правый фрейм
					var FRAME_RIGHT = bottom_frames[i+1];
					get_geometric_bounds( FRAME_RIGHT );
					// левая граница правого фрейма
					var FRAME_RIGHT_L = the_frame_left;
					// определяем вылеты
					// правый вылет левого фрейма
					var FRAME_LEFT_BLEED_RIGHT = GET_BLEED( bottom_frames_orient[i] )[3];
					// левый вылет правого фрейма
					var FRAME_RIGHT_BLEED_LEFT = GET_BLEED( bottom_frames_orient[i+1] )[1];
					// определяем ширину пространства для построения меток
					// в текущем вертикальном промежутке
					var GUTTER_H_VAL =
					( FRAME_RIGHT_L + FRAME_RIGHT_BLEED_LEFT - MARKS_OFFS_H ) -
					( FRAME_LEFT_R - FRAME_LEFT_BLEED_RIGHT + MARKS_OFFS_H );
					// возможность строить метки в данном промежутке по горизонтали
					var DRAW_BETWEEN_H = false;
					// пространство по горизонтали
					var D_GUTTER_H = GUTTER_H_VAL - MARKS_LEN_H;
					if( D_GUTTER_H < 0. && Math.abs( D_GUTTER_H ) <= PREC ) DRAW_BETWEEN_H = true;
					if( D_GUTTER_H >= 0. ) DRAW_BETWEEN_H = true;
					// если место есть копируем левые метки
					if( DRAW_BETWEEN_H )
					{
						var CH_LEFT = FRAME_LEFT_R - FRAME_LEFT_BLEED_RIGHT + MARKS_OFFS_H + MARKS_LEN_H/2.;
						// перемещение в левую часть промежутка
						var DX_GUT_LEFT = CH_LEFT - CH_START;
						var GUT_MARKS_H_L = MOVE_COPY_ARR( LEFT_MARKS, DX_GUT_LEFT, 0. );
						ADD_ARR ( ALL_MARKS, GUT_MARKS_H_L );
						// если в промежутке есть место для правых меток
						if( !( (GUTTER_H_VAL - MARKS_LEN_H ) <= PREC ) )
						{
							// левая граница правого фрейма
							var CH_RIGHT = FRAME_RIGHT_L + FRAME_RIGHT_BLEED_LEFT - MARKS_OFFS_H - MARKS_LEN_H/2.;
							// перемещение в правую часть промежутка
							var DX_GUT_RIGHT = CH_RIGHT - CH_START;
							var GUT_MARKS_H_R = MOVE_COPY_ARR( LEFT_MARKS, DX_GUT_RIGHT, 0. );
							ADD_ARR ( ALL_MARKS, GUT_MARKS_H_R );
						};// if
					};// if
				};// for
			};// if
		};// if-else
	};// if
	// если задано создание отдельного слоя для меток
	if( ADD_LAYER )
	{
		// переименовываем текущий слой
		SEL_LAYER.name = "FRAMES";
		// создаем новый слой
		var MARKS_LAYER = AD.layers.add();
		MARKS_LAYER.name = "MARKS";
		// перемещаем все метки на новый слой
		for( var i = 0; i < ALL_MARKS.length; i++ )
		{
			ALL_MARKS[i].itemLayer = MARKS_LAYER;
		};// for		
	};// if
	//
	// подпрограмма построения вертикальной направляющей
	function make_vertical_guide( x ) 
	{
		if( GUIDE_ALREADY_MADE( x, MADE_X ) ) return;
		var the_guide;
		if( !GUIDE_V_MASTER_MADE )
		{
			the_guide = AS.guides.add(SEL_LAYER);
			the_guide.orientation = HorizontalOrVertical.vertical;
			the_guide.fitToPage = true;
			GUIDE_V_MASTER_MADE = true;
		}
		else
		{
			the_guide = GUIDE_V_MASTER.duplicate();
		};// if-else
		the_guide.location = x;
		MADE_X.push( x );
		GUIDE_V_MASTER = the_guide;
		return;
	};// end make_vertical_guide
	//
	// подпрограмма построения горизонтальной направляющей
	function make_horizontal_guide( y ) 
	{
		if( GUIDE_ALREADY_MADE( y, MADE_Y ) ) return;
		var the_guide;
		if( !GUIDE_H_MASTER_MADE )
		{
			the_guide = AS.guides.add(SEL_LAYER);
			the_guide.orientation=HorizontalOrVertical.horizontal;
			the_guide.fitToPage = true;
			GUIDE_H_MASTER_MADE = true;
		}
		else
		{
			the_guide = GUIDE_H_MASTER.duplicate();
		};// if-else
		the_guide.location = y;
		MADE_Y.push( y );
		GUIDE_H_MASTER = the_guide;
		return;
	};// end make_horizontal_guide
	//
	// подпрограмма проверки создана ли направляющая с заданными координатами
	function GUIDE_ALREADY_MADE( a, arr )
	{
		try
		{
			for( var i=0; i < arr.length; i++ )
			{
				if( Math.abs(a - arr[i]) < PREC ) return true;
			};// for i
		} catch ( error ) {};
		return false;
	};// end GUIDE_ALREADY_MADE
	//
	// подпрограмма создания вертикальной метки
	function MAKE_MARK_VER(the_top, the_bottom, the_x)
	{
		if( ALREADY_MADE(the_x, the_top, the_x, the_bottom ) ) return false;
		var the_obj;
		// если мастер для вертикальной метки не создан
		if( !MASTER_VER_CROP_MADE )
		{
			the_obj = MAKE_MARK(the_top, the_x, the_bottom, the_x);
			MASTER_VER_CROP_MADE = true;
		}
		else
		// если мастер для вертикальной метки уже создан
		{
			try
			{
				the_obj = MASTER_VER_CROP.duplicate();
				var mx = the_obj.geometricBounds[1] + (the_obj.geometricBounds[3] - the_obj.geometricBounds[1])/2.;
				var my = the_obj.geometricBounds[0] + (the_obj.geometricBounds[2] - the_obj.geometricBounds[0])/2.;
				// перемещение по горизонтали
				var dx = the_x - mx;
				// перемещение по вертикали
				var dy = (the_top+(the_bottom-the_top)/2.) - my;
				// собственно перемещаем
				MOVE( the_obj, dx, dy );
			} catch ( error ) {};
		};// if-else
		MASTER_VER_CROP = the_obj;
		return  the_obj;
	};// end MAKE_MARK_VER
	//
	// подпрограмма создания горизонтальной метки
	function MAKE_MARK_HOR(the_left, the_right, the_y)
	{
		if( ALREADY_MADE(the_left, the_y, the_right, the_y ) ) return false;
		var the_obj;
		// если мастер для горизонтальной метки не создан
		if( !MASTER_HOR_CROP_MADE )
		{
			the_obj = MAKE_MARK(the_y, the_left, the_y, the_right);
			MASTER_HOR_CROP_MADE = true;
		}
		else
		// если мастер для горизонтальной метки уже создан
		{
			try
			{
				the_obj = MASTER_HOR_CROP.duplicate();
				var mx = the_obj.geometricBounds[1] + (the_obj.geometricBounds[3] - the_obj.geometricBounds[1])/2.;
				var my = the_obj.geometricBounds[0] + (the_obj.geometricBounds[2] - the_obj.geometricBounds[0])/2.;
				// перемещение по горизонтали
				var dx = (the_left+(the_right-the_left)/2.) - mx;
				// перемещение по вертикали
				var dy = the_y - my;
				// собственно перемещаем
				MOVE( the_obj, dx, dy );
			} catch ( error ) {};
		};// if-else
		MASTER_HOR_CROP = the_obj;
		return  the_obj;
	};// end MAKE_MARK_HOR
	//
	// подпрограмма создания метки
	function MAKE_MARK(the_top, the_left, the_bottom, the_right)
	{
		var the_obj;
		// если задан белый контур сначала делаем расширенную белую линию (1 pt)
		if( WHITE_CONT ) 
		{
			var W_L = MAKE_LINE(the_top, the_left, the_bottom, the_right, false, MARKS_SW_NUM+1.);
		}
		// собственно делаем линию цветом регистр.
		var R_L = MAKE_LINE(the_top, the_left, the_bottom, the_right, true, MARKS_SW_NUM);
		// создаем группу из белой и регистр. линии
		if( WHITE_CONT )
		{
			try
			{
				var G = AS.groups.add([W_L, R_L]);
				the_obj = G;
			} catch ( error ) {};
		}
		else the_obj = R_L;
		return the_obj;
	};// end MAKE_MARK
	//
	// подпрограмма создания линии
	function MAKE_LINE(the_top, the_left, the_bottom, the_right, the_color, the_weight)
	{
		try
		{
			// создаем новую линию на выбранном слое
			var the_line = app.activeWindow.activeSpread.graphicLines.add(SEL_LAYER);
			// снимаем заливку
			try { the_line.fillColor = AD.swatches.item("None") } catch (error) {};
			// ставим обводку по центру
			try { the_line.strokeAlignment = 1936998723 } catch (error) {};
			// снимаем окончания линий
			try { the_line.rightLineEnd = 1852796517 } catch (error) {};
			try { the_line.leftLineEnd = 1852796517 } catch (error) {};
			try { the_line.endCap = 1650680176 } catch (error) {};
			try { the_line.endJoin = 1835691886 } catch (error) {};
			// присваиваем обводку
			try { the_line.strokeColor = AD.swatches.item("Registration") } catch (error) {};
			//  если цвет истина ставим тинт на 100% (Registration)
			try 
			{
				if( the_color == true ) the_line.strokeTint = -1
				// если цвет ложь ставим тинт на 0% Registration (как бы белый :))
				else the_line.strokeTint = 0 ;
			} catch (error) {};
			// снимаем оверпринт
			try { the_line.overprintStroke = false } catch (error) {};
			// снимаем нонпринтинг
			try { the_line.nonprinting = false } catch (error) {};
			// ставим линию как сплошную
			try { the_line.strokeType = AD.strokeStyles.item("Solid") } catch (error) {};
			// снимаем угловые эффекты
			try { the_line.cornerOption = CornerOptions.NONE } catch (error) {};
			// присваиваем границы
			try { the_line.geometricBounds = [the_top, the_left, the_bottom, the_right] } catch (error) {};
			try { the_line.strokeWeight = the_weight } catch (error) {};
			// снимаем возможные эффекты обводки
			CLEAR_EFFECTS( the_line.strokeTransparencySettings );
			// снимаем возможные эффекты заливки
			CLEAR_EFFECTS( the_line.fillTransparencySettings );
			// снимаем возможные эффекты объекта
			CLEAR_EFFECTS( the_line.transparencySettings );
			return the_line;
		} catch ( error ) {};
	};// end MAKE_LINE
	//
	// подпрограмма проверки создана ли уже метка
	function ALREADY_MADE( L, T, R, B )
	{
		try
		{
			for( var i=0; i < ALL_MARKS.length; i++ )
			{
				var ALL_MARKS_i = ALL_MARKS[i];
				var T_i = ALL_MARKS_i.geometricBounds[0];
				var L_i = ALL_MARKS_i.geometricBounds[1];
				var B_i = ALL_MARKS_i.geometricBounds[2];
				var R_i = ALL_MARKS_i.geometricBounds[3];
				if( ( ( Math.abs( L -  L_i ) ) < PREC ) && 
					 ( ( Math.abs( T - T_i ) ) < PREC ) && 
					 ( ( Math.abs( R - R_i ) ) < PREC ) && 
					 ( ( Math.abs( B - B_i ) ) < PREC ) ) {return true};
			};// for i
		} catch ( error ) {};
		return false;
	};// end ALREADY_MADE
	return;
};// end ADD_CROPS
//
// подпрограмма создания нового документа
function CREATE_DOC()
{
	try
	{
		// создаем новый документ
		AD = app.documents.add( true );
		// устанавливаем единицы измерения
		AD.viewPreferences.horizontalMeasurementUnits = 
		AD.viewPreferences.verticalMeasurementUnits = 
		GET_RULER_UNITS_FROM_INDEX( UNITS );
		// устанавливаем размеры документа
		AD.documentPreferences.pageHeight = DOC_H;
		AD.documentPreferences.pageWidth = DOC_W;
	}
	catch ( error )
	{
		// если ошибка закрываем созданный документ 
		// без запроса на сохранение без сохранения
		try
		{
			AD.close( 1852776480 );
		} catch ( error ) {};// try-catch
		// аварийный выход
		the_exit( "Can not set the document size!" );
	};// if-else
	// включаем показ границ фреймов
	try
	{
		AD.viewPreferences.showFrameEdges = true;
	} 
	catch ( error ) {};// try-catch
	// только 1 полоса на развороте
	AD.documentPreferences.facingPages = false;
	// определяем активный слой
	AL = AD.activeLayer;
	// выбранный слой для построения объектов
	SEL_LAYER = AL;
	// определяем активную страницу
	AP = app.activeWindow.activePage
	// определяем активный разворот
	AS = app.activeWindow.activeSpread;
	// ставим отсчет как для разворота
	AD.viewPreferences.rulerOrigin = RulerOrigin.spreadOrigin;
	// устанавливаем точку отсчета координат в исходное положение
	AD.zeroPoint = [0., 0.];
	var MS = AD.masterSpreads[0];
	var MS_NP = MS.pages.length;
	// удаляем лишние страницы на мастере
	// (если они есть)
	if( MS_NP > 1 )
	{
		for( var i = MS_NP -1; i > 0; i-- )
		{
			try
			{
				MS.pages[i].remove();
			} catch ( error ) {};// try-catch
		};// for
	};// if
	// удаляем лишние страницы документа
	// (если они есть)
	var D_NP = AD.pages.length;
	if( D_NP > 1 )
	{
		for( var i = D_NP -1; i > 0; i-- )
		{
			try
			{
				AD.pages[i].remove();
			} catch ( error ) {};
		};// for
	};// if
	// мастер страница
	MP = MS.pages[0];
	// очищаем страницы (если есть от чего)
	// мастер
	CLEAR_PAGE( MP );
	// страница документа
	CLEAR_PAGE( AP );
	// устанавливаем поля на мастере
	SET_MARGINS(MP, MARGIN_T, MARGIN_L, MARGIN_B, MARGIN_R);
	// устанавливаем поля на первой странице
	SET_MARGINS(AP, MARGIN_T, MARGIN_L, MARGIN_B, MARGIN_R);
	return;
};// end CREATE_DOC
//
// очистка страницы
function CLEAR_PAGE( the_page )
{
	var objs = the_page.pageItems;
	for( var i = objs.length-1; i >= 0; i-- )
	{
		try
		{
			objs[i].remove();
		} catch ( error ) {};// try-catch
	};// for
	return;
};// end  CLEAR_PAGE
//
// подпрограмма назначения полей страницам
function SET_MARGINS(the_page, the_top, the_left, the_bottom, the_right)
{
	try
	{
		with( the_page.marginPreferences )
		{
			// поля
			top = the_top;
			bottom = the_bottom;
			left = the_left;
			right = the_right;
			// колонки - только одна
			columnCount = 1;
		};// with
	} catch ( error ) {};// try-catch
	return;	
};// end SET_MARGINS
//
// подпрограмма определения является ли число НЕчетным
function IS_ODD( x )
{
	var ost = x/2.;
	var ost_int = parseInt(ost)
	if( (ost - ost_int) == 0. ) return false
	return true;
};// end IS_ODD
//
// подпрограмма перемещения объекта
function MOVE( the_obj, X, Y )
{
	try
	{
		the_obj.move( undefined, [X, Y] );
	} 
	catch( error ){};
	return the_obj;
};// end MOVE
//
// подпрограмма создания фреймов
function ADD_FRAMES()
{
	// текущие значения координат границ фрейма
	var T_i;// верхняя
	var L_j;// левая
	var R_j;// правая
	var B_i;// нижняя
	// угол поворота фрейма
	var the_angle = 0.;// Head Up
	// точка поворота фрейма: центр
	var the_ancor = AnchorPoint.CENTER_ANCHOR;
	// значение шага для промежутка по горизонтали 
	var H_GUT_STEP = GUTTER_H;
	var H_GUT_ON = true;
	if( H_GUT_CENTER )
	{
		H_GUT_STEP = 0.;
		H_GUT_ON = false;
	};// if
	// значение шага для промежутка по вертикали 
	var V_GUT_STEP = GUTTER_V;
	var V_GUT_ON = true;
	if( V_GUT_CENTER )
	{
		V_GUT_STEP = 0.;
		V_GUT_ON = false;
	};// if
	// полные размеры фрейма
	W_FULL = W_FINAL + ( BLEED_R + BLEED_L );
	H_FULL = H_FINAL + ( BLEED_T + BLEED_B );
	// число промежутков
	N_GUT_V = N_FRAMES_V - 1;
	N_GUT_H = N_FRAMES_H - 1;
	//
	// запоминаем начальные значения для длин меток и отступов
	if( !( MARKS_LEN_H == 0. && MARKS_LEN_V == 0. ) )
	{
		MARKS_LEN_H_INI = MARKS_LEN_H;
		MARKS_LEN_V_INI = MARKS_LEN_V;
		MARKS_OFFS_H_INI = MARKS_OFFS_H;
		MARKS_OFFS_V_INI = MARKS_OFFS_V;
	};// if
	// запоминаем начальное значение для создания дополнительного слоя
	ADD_LAYER_INI = ADD_LAYER;
	// если нет построения меток обнуляем длины меток и вылетов
	if( !DRAW_CROP )
	{ 
		MARKS_LEN_V_B = MARKS_LEN_H_R = 
		MARKS_LEN_H = MARKS_LEN_V = 
		MARKS_OFFS_H = MARKS_OFFS_V = 0.;
	};// if
	// начальное значение низа самого первого фрейма
	var B_i_DY = MARKS_LEN_V_B;
	// если метки вне фреймов
	if( CROP_OUT ) B_i_DY = MARKS_LEN_V + MARKS_OFFS_V;
	B_i = DOC_H - B_i_DY - MARGIN_B;
	// начальное значение левого края для первых фреймов в рядах
	var L_j_0_DX = MARKS_LEN_H_L;
	// если метки вне фреймов
	if( CROP_OUT ) L_j_0_DX = MARKS_LEN_H + MARKS_OFFS_H;
	// левая граница самого первого фрейма
	var L_j_0 = MARGIN_L + L_j_0_DX;
	// цикл по вертикали
	for( var i = N_FRAMES_V-1; i >= 0; i--)
	{
		// текущая верхняя граница фрейма
		T_i = B_i - H_FULL;
		// текущая левая граница фрейма для ряда по горизонтали
		L_j = L_j_0;
		FRAMES[i] = new Array();
		FRAMES_ORIENT[i] =  new Array();
		// цикл по горизонтали
		for( var j = 0; j < N_FRAMES_H; j++ )
		{
			// текущая правая граница фрейма
			R_j = L_j + W_FULL;
			FRAMES[i][j] = MAKE_FRAME(T_i , L_j, B_i, R_j);
			FRAMES_ORIENT[i][j] = 0.;
			// самый первый создаваемый фрейм
			if( (i == (N_FRAMES_V-1)) && (j == 0) )
			{
				// если заданы повороты и/или смена ориентации
				if( ORIENT != 0 || CHANGE )
				{
					if( ORIENT == 1 )
					{
						the_angle = -90.;// Head Right
					};//if
					if( ORIENT == 2 ) 
					{
						the_angle = 180.;// Head Down
					};// if
					if( ORIENT == 3 ) 
					{
						the_angle = 90.;// Head Left
					};// if
					// поворачиваем самый первый фрейм
					ROTATE_FRAME( i, j, FRAMES[i][j], the_angle, the_ancor );
					// корректируем положение фрейма после поворота
					// получаем координаты 
					var F_0_T =  FRAMES[i][j].geometricBounds[0];// верхняя
					var F_0_L =  FRAMES[i][j].geometricBounds[1];// левая
					var F_0_B =  FRAMES[i][j].geometricBounds[2];// нижняя
					var F_0_R =  FRAMES[i][j].geometricBounds[3];// правая
					// рассчитываем перемещения
					var F_0_DX = L_j -  F_0_L;
					var F_0_DY = F_0_T - T_i;
					// перемещаем
					MOVE( FRAMES[i][j], F_0_DX, F_0_DY );
					// вычисляем координаты после перемещения
					T_i = FRAMES[i][j].geometricBounds[0];// верхняя
					L_j = FRAMES[i][j].geometricBounds[1];// левая
					B_i = FRAMES[i][j].geometricBounds[2];// нижняя
					R_j = FRAMES[i][j].geometricBounds[3];// правая
					// переназначаем ширину и высоту после поворота
					if( (ORIENT == 1 || ORIENT == 3) )
					{
						W_FULL = H_FINAL + ( BLEED_T + BLEED_B );
						H_FULL  = W_FINAL + ( BLEED_R + BLEED_L );
					};// if
					// мастер для новых фреймов
					MASTER_RECT = FRAMES[i][j];
				};// if
			}
			// если не первый фрейм по горизонтали
			else
			{
				// если поворот вправо или влево и чередование голова-ноги
				if( (ORIENT == 1 || ORIENT == 3) && CHANGE ) 
				{
					if( IS_ODD( j ) )
					{
						ROTATE_FRAME(  i, j, FRAMES[i][j], the_angle - 180., the_ancor );
					}
					else
					{
						ROTATE_FRAME(  i, j, FRAMES[i][j], the_angle, the_ancor );
					};// if-else
				};// if
				// если поворот верх или вниз и чередование голова-ноги
				if( (ORIENT == 0 || ORIENT == 2) && CHANGE )
				{
					var k = (N_FRAMES_V-1) - i;
					if( IS_ODD( k ) )
					{
						ROTATE_FRAME(  i, j, FRAMES[i][j], the_angle - 180., the_ancor );
					}
					else
					{
						ROTATE_FRAME(  i, j, FRAMES[i][j], the_angle, the_ancor );
					};// if-else
				};// if
				// если НЕТ чередования голова-ноги
				if( !CHANGE )
				{
					// ориентация всех фреймов как у самого первого созданного фрейма
					FRAMES_ORIENT[i][j] = FRAMES_ORIENT[N_FRAMES_V-1][0];
				};// if
			};// if-else
			if( H_GUT_CENTER && ( j+1 == (N_FRAMES_H/2 ) )  ) H_GUT_STEP  = GUTTER_H;
			if( 
				 (H_GUT_CENTER && (  j+1 < (N_FRAMES_H/2 ) ) ) ||
				 (H_GUT_CENTER && (  j+1 > (N_FRAMES_H/2 ) ) )
			)  H_GUT_STEP  = 0.;
			// текущая левая граница фрейма
			L_j = R_j + H_GUT_STEP;
		};// for j
		if( V_GUT_CENTER && ( i == (N_FRAMES_V/2 ) )  ) V_GUT_STEP  = GUTTER_V;
		if( 
		     (V_GUT_CENTER && (  i < (N_FRAMES_V/2 ) ) ) ||
		     (V_GUT_CENTER && (  i > (N_FRAMES_V/2 ) ) )
		   )  V_GUT_STEP  = 0.;
		// текущая нижняя граница фрейма
		B_i = T_i - V_GUT_STEP;
	};// for i
	// наполняем массивы крайних рядов фреймов для построения меток и направляющих
	// самые верхние
	for( var i=0; i < N_FRAMES_H; i++ )
	{
		top_frames[i] = FRAMES[0][i];
		top_frames_orient[i] = FRAMES_ORIENT[0][i];
	};// for
	// самые нижние
	for( var i=0; i < N_FRAMES_H; i++ ) 
	{
		bottom_frames[i] = FRAMES[N_FRAMES_V - 1][i];
		bottom_frames_orient[i] = FRAMES_ORIENT[N_FRAMES_V - 1][i];
	};// for
	// самые левые
	for( var i=0; i < N_FRAMES_V; i++ ) 
	{
		left_frames[i] = FRAMES[i][0];
		left_frames_orient[i] = FRAMES_ORIENT[i][0];
	};// for
	// самые правые
	for( var i=0; i < N_FRAMES_V; i++ ) 
	{
		right_frames[i] = FRAMES[i][N_FRAMES_H - 1];
		right_frames_orient[i] = FRAMES_ORIENT[i][N_FRAMES_H - 1];
	};// for
	return;	
};// end ADD_FRAMES
//
// подпрограмма поворота фрейма
function ROTATE_FRAME( i, j, F, A, ancor )
{
	// начальный угол поворота фрейма
	var F_angle = F.rotationAngle;
	// возвращаем в исходное положение
	F_angle = - F_angle;
	var the_rotation = app.transformationMatrices.add({counterclockwiseRotationAngle:F_angle});
	F_transform();
	// поворачиваем на нужный угол
	var the_rotation = app.transformationMatrices.add({counterclockwiseRotationAngle:A});
	F_transform();
	// собственно функция поворота
	function F_transform()
	{
		F.transform
		(
			CoordinateSpaces.INNER_COORDINATES, 
			ancor, 
			the_rotation,
			undefined,
			true
		);
		return;
	};// end F_transform
	FRAMES_ORIENT[i][j] = A;
	return;
};// end ROTATE_FRAME
//
// подпрограмма создания фрейма
function MAKE_FRAME(the_top, the_left, the_bottom, the_right )
{
	var the_obj;
	try
	{
		// если не создан мастер прямоугольник
		if( !MASTER_RECT_MADE )
		{
			// создаем новый прямоугольник на выбранном слое
			the_obj = app.activeWindow.activeSpread.rectangles.add(SEL_LAYER)
			// ставим заливку
			try { the_obj.fillColor = "None" } catch (error) {};
			try { the_obj.fillTint = -1 } catch (error) {};
			// ставим обводку по центру
			try { the_obj.strokeAlignment = 1936998723 } catch (error) {};
			// снимаем окончания линий
			try { the_obj.rightLineEnd = 1852796517 } catch (error) {};
			try { the_obj.leftLineEnd = 1852796517 } catch (error) {};
			try { the_obj.endCap = 1650680176 } catch (error) {};
			try { the_obj.endJoin = 1835691886 } catch (error) {};
			// снимаем обводку
			try { the_obj.strokeColor = AD.swatches.item("None") } catch (error) {};
			// снимаем оверпринт
			try { the_obj.overprintStroke = false } catch (error) {};
			// снимаем нонпринтинг
			try { the_obj.nonprinting = false } catch (error) {};
			// ставим линию как сплошную
			try { the_obj.strokeType = AD.strokeStyles.item("Solid") } catch (error) {};
			// снимаем угловые эффекты
			try { the_obj.cornerOption = CornerOptions.NONE } catch (error) {};
			// присваиваем границы
			try { the_obj.geometricBounds = [the_top, the_left, the_bottom, the_right] } catch (error) {};
			try { the_obj.strokeWeight = the_weight } catch (error) {};
			// снимаем возможные эффекты обводки
			CLEAR_EFFECTS( the_obj.strokeTransparencySettings );
			// снимаем возможные эффекты заливки
			CLEAR_EFFECTS( the_obj.fillTransparencySettings );
			// снимаем возможные эффекты объекта
			CLEAR_EFFECTS( the_obj.transparencySettings );
			// ставим тип содержимого (графика)
			the_obj.contentType = ContentType.GRAPHIC_TYPE;
			// мастер объект создан
			MASTER_RECT_MADE = true;
		}
		else
		// если мастер объект создан
		{
			// дублируем мастер объект
			try { the_obj = MASTER_RECT.duplicate() } catch (error) {};
			// получаем границы копии мастера
			var  the_obj_T =  the_obj.geometricBounds[0];
			var  the_obj_L =  the_obj.geometricBounds[1];
			var  the_obj_B =  the_obj.geometricBounds[2];
			var  the_obj_R =  the_obj.geometricBounds[3];
			// вычисляем перемещения
			var the_obj_DX =  (the_left + (the_right - the_left)/2.) - (the_obj_L + (the_obj_R - the_obj_L)/2.);
			var the_obj_DY =  (the_top + (the_bottom - the_top)/2.) - (the_obj_T + (the_obj_B - the_obj_T)/2.);
			// перемещаем
			MOVE( the_obj, the_obj_DX, the_obj_DY );
		};// if-else
		// присваиваем созданный прямоугольник как мастер объект
		MASTER_RECT = the_obj;
		return the_obj;
	} catch ( error ) {};
};// end MAKE_FRAME
//
// обработка поля ввода в процессе ввода
function digit_on_Changing(et, def, emp) 
{
	var s =et.text;
	if( s == "") 
	{
		et.text = emp;
		return;
	};
	if( !INP_OK ) 
	{
		et.text = def;
		INP_OK = true;
		return;
	}
	var d;
	var BNP = false;
	var N_C = 0;
	var N_P = 0;
	var N_M = 0;
	for( var i=0; i < s.length; i++ ) 
	{
		var si = s[i];
		if( si == "." || si == "," ) N_C = N_C +1;
		if( si == "-" ) N_M = N_M +1;
		if( si == "+" ) N_P = N_P +1;
		if
			( 
			((si != "-" && si != "+" && si != "." && si != "," && NO_DIGIT_SYMBOL(si)) || N_C>1 ) ||
			((N_P + N_M)>1) ||
			( si == "-"  && i !=0 ) ||
			( si == "+"  && i !=0 )
			) 
		{
			BNP = true;
			et.active = true;
			INP_OK = false;
			alert("Bad number input!");
			et.text = def;
			return;
		};// if
	};// for
	return;
};// end digit_on_Changing
//
// функция чтения текстового ввода и перевода в число
function TEXT_TO_DIGIT ( txt ) 
{
	var s = "";
	// если пусто то ноль
	if( txt == "" ) s = "0";
	if( txt == "+" ) s = "0";
	if( txt == "-" ) s = "0";
	var only_space = true;
	for( var i=0; i < txt.length; i++ ) 
	{
		if( txt[i] != " " ) only_space = false;
		if( txt[i] == ",") s = s + "." else s = s + txt[i];
	};// for
	// если только пробелы то ноль
	if( only_space ) s = "0";
	if( s == ".")  s = "0";
	if( s == "-")  s = "0";
	var s1 = "";
	for( var i=0; i < s.length; i++ ) 
	{
		if( s[i] == " " ) continue;
		s1 = s1 + s[i];
	};// for
	var d = parseFloat( s1 );
	return d;
};// end TEXT_TO_DIGIT
//
// подпрограмма получения геометрических границ фрейма
function GET_FRAME_BOUNDS ( the_obj ) 
{
	// left
	var g_L =  the_obj.geometricBounds[1];// 0
	// top
	var g_T =  the_obj.geometricBounds[0];// 1
	// right
	var g_R =  the_obj.geometricBounds[3];// 2
	// bottom
	var g_B =  the_obj.geometricBounds[2];// 3
	//               0       1        2       3 
	return [g_L, g_T, g_R, g_B];
};// end GET_FRAME_BOUNDS
//
// подпрограмма присвоения значения переменной
// в зависимости от файловой системы
function WM( W, M )
{
	if( WFS ) return W
	else return M;
};// end WM
//
// подпрограмма получения версии приложения (InDesign)
function APP_VERSION()
{
	// 3=CS; 4=CS2; 5=CS3; 6=CS4; 7=CS5; 8=CS6
	var V = parseInt(app.version);
	return V;	
};// end APP_VERSION